#include "stdafx.h"
#include "Form1.h"

namespace FormulaGUI {

	using namespace System;
	using namespace System::IO;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

//--------------------------------------------------------------------------------------------------
System::Void Form1::localtrackBar_Scroll(System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	int i;
	localtrackBar = (System::Windows::Forms::TrackBar^) sender;
	System::Int32::TryParse(localtrackBar->Text,i);
	ShowTrack(i);

	if ( MyGUIData->DataLoaded )
	{
		MyOpenGLPlot->Draw();
		this->label1->Text = L"TargetValue = " + MyGUIData->MyRun->targetvalue.ToString("f6");
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::localtrackBar_Enter(System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	int i;

	localtrackBar = (System::Windows::Forms::TrackBar^) sender;
	System::Int32::TryParse(localtrackBar->Text,i);
 
	if ( i == currentslider ) return;
    
	mytextBox1[currentslider]->BackColor = System::Drawing::Color::White; 
	mytextBox1[i]->BackColor             = System::Drawing::Color::LightSkyBlue;
   currentslider = i;
	setrange = 0;

	if ( MyGUIData->DataLoaded ) MyOpenGLPlot->Draw();
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::localtextBox_Edit (System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	int i,j;

	if ( MyGUIData->DataLoaded )
	{
		localtextBox = (System::Windows::Forms::TextBox^) sender;
		System::Int32::TryParse(localtextBox->Text,i);
		System::Int32::TryParse(localtextBox->Name,j); 
//
// --- slider value set in textbox window
//
		SetSlider(i,j);
		SetChangedValues(j);
		MyOpenGLPlot->Draw();
		this->label1->Text = L"TargetValue = " + MyGUIData->MyRun->targetvalue.ToString("f6");
		currentslider = j;
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::localcheckBox_Changed (System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	int j;

	if ( MyGUIData->DataLoaded )
	{
		localcheckBox = (System::Windows::Forms::CheckBox^) sender;
		System::Int32::TryParse(localcheckBox->Name,j);

		mytextBox1[currentslider]->BackColor = System::Drawing::Color::White; 
		mytextBox1[j]->BackColor             = System::Drawing::Color::LightSkyBlue; 
		currentslider = j;

		if ( localcheckBox->CheckState == System::Windows::Forms::CheckState::Checked   ) this->MyGUIData->MyRun->Set_desvar(j,2);
		if ( localcheckBox->CheckState == System::Windows::Forms::CheckState::Unchecked ) this->MyGUIData->MyRun->Set_desvar(j,0);
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::localtextBox_Enter (System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	int    j;

	if ( MyGUIData->DataLoaded )
	{
		localtextBox = (System::Windows::Forms::TextBox^) sender;

		System::Int32::TryParse(localtextBox->Name,j);
		mytextBox1[currentslider]->BackColor = System::Drawing::Color::White; 
		mytextBox1[j]->BackColor             = System::Drawing::Color::LightSkyBlue; 
		currentslider = j;
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::localtextBox_Changed (System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	if ( MyGUIData->DataLoaded ) mytrackBar[currentslider]->Value = 33;
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::localtextBox_Leave (System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	double value;

	if ( MyGUIData->DataLoaded ) 
	{
		mytextBox1[currentslider]->Text = mytextBox1[currentslider]->Text->Replace(".",",");
		System::Double::TryParse(mytextBox1[currentslider]->Text,value); 
		MyGUIData->MyRun->input1[currentslider] = value; 
		MyGUIData->Evaluate();
		MyOpenGLPlot->Draw();
		this->label1->Text = L"TargetValue = " + MyGUIData->MyRun->targetvalue.ToString("f6");
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::LoadReferenceFile_Click(System::Object^  sender, System::EventArgs^  e) 
//--------------------------------------------------------------------------------------------------
{
	MyGUIData->LoadData(1);

	if ( MyGUIData->DataLoaded ) 
	{
		MyOpenGLPlot->Set_MeaData (MyGUIData->MyRun->Get_Optidata());
		MyOpenGLPlot->Set_SimData (MyGUIData->MyRun->Get_Simdata ());
		MyOpenGLPlot->Set_MeainfoD(MyGUIData->MyRun->Get_MeainfoD());
		MyOpenGLPlot->Set_MeainfoN(MyGUIData->MyRun->Get_MeainfoN());   
		MyOpenGLPlot->Set_MeainfoF(MyGUIData->MyRun->Get_MeainfoF());  
		MyOpenGLPlot->Set_MeainfoA(MyGUIData->MyRun->Get_MeainfoA());  
		MyOpenGLPlot->Set_FileName1(MyGUIData->File1);
		MyOpenGLPlot->Set_FileName2(MyGUIData->File2);
		MyOpenGLPlot->Set_FileName3(MyGUIData->File3);
		MyOpenGLPlot->Draw();
		this->label1->Text = L"TargetValue = " + MyGUIData->MyRun->targetvalue.ToString("f6");
	}
	if ( MyGUIData->DataLoaded ) 
	{
		MyGUIData->Evaluate();
		MyGUIData->GetData();
		SetAllValues();
		MyOpenGLPlot->Draw();
		this->label1->Text = L"TargetValue = " + MyGUIData->MyRun->targetvalue.ToString("f6");
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::LoadParameterFile_Click(System::Object^  sender, System::EventArgs^  e) 
//--------------------------------------------------------------------------------------------------
{	
	String ^string;
//
// --- make no redraw while restoring data from input file, reset slider
//
	ReDrawOpenGL = 0;
	for ( int i=0; i<Numberofsliders; i++) mycheckBox[i]->Checked = false;
//
// --- read input data
//
	MyGUIData->LoadParameter();
	string = this->MyGUIData->ConvertCharToString(MyGUIData->MyRun->WorkDirectory); 
	Directory::SetCurrentDirectory(string);
	this->label8->Text = MyGUIData->JobTitle;

	switch(MyGUIData->MyRun->Get_version())
	{
		case 201: 
		{
			Numberofsliders = 30;
			if ( Numberofsliders < CurrentNumberofsliders ) HideTracks (Numberofsliders,CurrentNumberofsliders);
			CurrentNumberofsliders = Numberofsliders;
			break;
		}
		case 202: 
		{
			Numberofsliders = 32;
			if ( Numberofsliders > CurrentNumberofsliders ) ShowTracks (CurrentNumberofsliders,Numberofsliders);
			CurrentNumberofsliders = Numberofsliders;
			break;
		}
		case 203: 
		{
			Numberofsliders = 42;
			if ( Numberofsliders > CurrentNumberofsliders ) ShowTracks (CurrentNumberofsliders,Numberofsliders);
			CurrentNumberofsliders = Numberofsliders;
			break;
		}
		case 204: 
		{
			Numberofsliders = 44;
			if ( Numberofsliders > CurrentNumberofsliders ) ShowTracks (CurrentNumberofsliders,Numberofsliders);
			CurrentNumberofsliders = Numberofsliders;
			break;
		}
		default: 
		{
			Numberofsliders = 30;
			if ( Numberofsliders < CurrentNumberofsliders ) HideTracks (Numberofsliders,CurrentNumberofsliders);
			CurrentNumberofsliders = Numberofsliders;
			break;
		}
	};

   this->label9->Text = "Data set version = " + MyGUIData->MyRun->Get_version().ToString();

	for ( int i=0; i<Numberofsliders; i++)
	{
		myLabel[i]->Text       = MyGUIData->strarray[i];
		mytextBox[i]->Text     = L"33";
		mytextBox1[i]->Text    = myToString(MyGUIData->baseinput[i]);
		mytextBox2[i]->Text    = myToString(MyGUIData->newinput[i]);
		if ( MyGUIData->MyRun->Is_desvar(i) ) mycheckBox[i]->Checked::set(true);
	}
//
// --- allow redraw and do 
//
	ReDrawOpenGL = 1;
	if ( MyGUIData->DataLoaded ) 
	{
		MyGUIData->Evaluate();
		MyOpenGLPlot->Draw();
		this->label1->Text = L"TargetValue = " + MyGUIData->MyRun->targetvalue.ToString("f6");
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::LoadMFDataFile  (System::Object^  sender, System::EventArgs^ e) 
//--------------------------------------------------------------------------------------------------
{
	MyGUIData->LoadMFData();
	this->label8->Text::set(MyGUIData->MFName);
	MFDataLoaded = 1;
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::SaveParameterFile_Click(System::Object^  sender, System::EventArgs^  e) 
//--------------------------------------------------------------------------------------------------
{
	for ( int i=0; i<Numberofsliders; i++)
	{
//
// --- ensure current values due to base and slider position
//
		ReDrawOpenGL = 0;
		SetChangedValues(i);
		ReDrawOpenGL = 1;
//
// --- get data from slidervalue*basevalue
//
		System::Double::TryParse(mytextBox2[i]->Text,MyGUIData->MyRun->input1[i]); 
	   if ( mycheckBox[i]->CheckState == System::Windows::Forms::CheckState::Checked   ) this->MyGUIData->MyRun->Set_desvar(i,2);
		if ( mycheckBox[i]->CheckState == System::Windows::Forms::CheckState::Unchecked ) this->MyGUIData->MyRun->Set_desvar(i,0);
	}
//
// --- write data
//
	MyGUIData->SaveParameter();
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::SaveGraphis_Click(System::Object^  sender, System::EventArgs^  e) 
//--------------------------------------------------------------------------------------------------
{
	if ( MyGUIData->SaveGraphis() ) MyOpenGLPlot->GeneratePicture(MyGUIData->File4);
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::Sensitivity_Click(System::Object^  sender, System::EventArgs^  e) 
// -------------------------------------------------------------------------------------------------------------
{
	int    i,bestIndex,jslider;
	double value1,value2,value3,value4,bestTarget,bestValue;
   FILE *SENSITY;
   FILE *GNUFILE;
	String ^str;

   if ( currentslider < 0 || currentslider > Numberofsliders-1 ) return;
	if ( MyGUIData->DataLoaded == 0 ) return;

	if ( ( SENSITY = fopen ("sensity.dat","w+") ) == NULL ) return;
//
// --- get base value
//
	System::Double::TryParse(mytextBox1[currentslider]->Text,value1);
	value4 = value1;
//
// --- do sensitivity analysis
//
	jslider = Get_islider();
	progressBar1->Maximum = jslider;
	progressBar1->Step    = 1;

	if ( setrange ) 
	{
		value1 = Get_rangemin();
		value2 = Get_rangemax();
		for ( i=0; i<jslider; i++ )
		{
			value3 = value1 + (value2 - value1)*((double) i)/((double)(jslider-1));
			MyGUIData->MyRun->input1[currentslider] = value3;
			MyGUIData->Evaluate();
			fprintf (SENSITY," %+12.6e %+12.6e\n",value3,MyGUIData->target);
			progressBar1->Value::set(i);

			if ( i == 0 )
			{
				bestTarget = MyGUIData->target;
				bestValue  = value3;
				bestIndex  = 0;
			}
			else
			{
				if ( bestTarget > MyGUIData->target ) 
				{
					bestTarget = MyGUIData->target;
					bestValue  = value3;
					bestIndex  = i;
				}
			}
		}
	}
	else
	{
		for ( i=0; i<jslider; i++ )
		{
			value3 = value1*(0.5 + 3.0*((double) i)/((double)(jslider-1)));
			MyGUIData->MyRun->input1[currentslider] = value3;
			MyGUIData->Evaluate();
			fprintf (SENSITY," %+12.6e %+12.6e\n",value3,MyGUIData->target);
			progressBar1->Value::set(i);

			if ( i == 0 )
			{
				bestTarget = MyGUIData->target;
				bestValue  = value3;
				bestIndex  = 0;
			}
			else
			{
				if ( bestTarget > MyGUIData->target ) 
				{
					bestTarget = MyGUIData->target;
					bestValue  = value3;
					bestIndex  = i;
				}
			}
		}
	}
//
// --- reset drawings
//
	fclose (SENSITY);
	this->progressBar1->Value::set(0);

	MyGUIData->MyRun->input1[currentslider] = value4;
	MyGUIData->Evaluate();
	MyOpenGLPlot->Draw();

	str = this->MyGUIData->strarray[currentslider]->Trim();

	if ( ( GNUFILE = fopen ("SensitySingle.gp","w+") ) == NULL ) return;
	fprintf  (GNUFILE,"reset\n");
	fprintf  (GNUFILE,"set term win\n");
	fprintf  (GNUFILE,"set title \"variable <%s> with target = %+10.4e at value = %+10.4e [%2d]\"\n",str,bestTarget,bestValue,bestIndex);
	fprintf  (GNUFILE,"set ylabel \"target\"\n");
	fprintf  (GNUFILE,"set xlabel \"variable value\"\n");
	fprintf  (GNUFILE,"set grid\n");
	fprintf  (GNUFILE,"#set yrange [0:10]\n");
	fprintf  (GNUFILE,"plot \\\n");
	fprintf  (GNUFILE,"\"sensity.dat\" u 1:2 notitle w lp lt 1 lw 3\n");
	fprintf  (GNUFILE,"pause -1\n");
	fclose   (GNUFILE);
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::SensitivityAll_Click(System::Object^  sender, System::EventArgs^  e) 
// -------------------------------------------------------------------------------------------------------------
{
	int    i,j,bestIndex,jslider;
	double value1,value3,bestTarget,bestValue;
   FILE *SENSITY;
   FILE *GNUFILE;
	char  s[1024];
	String ^str;

	if ( MyGUIData->DataLoaded == 0 ) return;

	if     ( (GNUFILE = fopen ("SensityMulti.gp","w+") ) == NULL ) return;
	fprintf  (GNUFILE,"reset\n");
	fprintf  (GNUFILE,"set term win\n");
	fprintf  (GNUFILE,"set ylabel \"target\"\n");
	fprintf  (GNUFILE,"set xlabel \"variable value\"\n");
	fprintf  (GNUFILE,"set grid\n");
	fprintf  (GNUFILE,"#set yrange [0:10]\n");

	jslider = Get_islider();

	progressBar1->Maximum::set(jslider);
	progressBar1->Minimum::set(0);
	progressBar1->Step::set(1);

	for ( j=0; j<Numberofsliders-3; j++ )
	{
		if ( j < 10 ) sprintf (s,"sensity0%d.dat",j);
		else          sprintf (s,"sensity%d.dat",j);

		if ( ( SENSITY = fopen (s,"w+") ) == NULL ) return;
//
// --- get base value
//
		System::Double::TryParse(mytextBox1[j]->Text,value1);
		mytextBox1[j]->BackColor = System::Drawing::Color::LightSkyBlue;		 
		mytextBox1[j]->Update();
		if ( j > 0 ) 
		{
			mytextBox1[j-1]->BackColor = System::Drawing::Color::White; 		
			mytextBox1[j-1]->Update();
		}
//
// --- do sensitivity analysis
//
		for ( i=0; i<jslider; i++ )
		{
			value3 = value1*(0.5 + 3.0*((double) i)/((double)(jslider-1)));
			MyGUIData->MyRun->input1[j] = value3;
			MyGUIData->Evaluate();
			fprintf (SENSITY," %+12.6e %+12.6e\n",value3,MyGUIData->target);
			progressBar1->Value::set(i);

			if ( i == 0 )
			{
				bestTarget = MyGUIData->target;
				bestValue  = value3;
				bestIndex  = 0;
			}
			else
			{
				if ( bestTarget > MyGUIData->target ) 
				{
					bestTarget = MyGUIData->target;
					bestValue  = value3;
					bestIndex  = i;
				}
			}
		}
//
// --- drawings and reset or value 
//
		fclose (SENSITY);
		if   ( bestValues ) MyGUIData->MyRun->input1[j] = bestValue;
		else                MyGUIData->MyRun->input1[j] = value1;

		MyGUIData->Evaluate();
		MyOpenGLPlot->Draw();

		str = this->MyGUIData->strarray[j]->Trim();
		fprintf  (GNUFILE,"set title \"variable <%s> with target = %+10.4e at value = %+10.4e [%2d/%2d]\"\n",str,bestTarget,bestValue,bestIndex,jslider);
		fprintf  (GNUFILE,"plot \\\n");
		fprintf  (GNUFILE,"\"%s\" u 1:2 notitle w lp lt 1 lw 3\n",s);
		fprintf  (GNUFILE,"pause -1\n");
	}
	fclose   (GNUFILE);
   this->progressBar1->Value::set(0);
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::SensitivityAllSelected_Click(System::Object^  sender, System::EventArgs^  e) 
// -------------------------------------------------------------------------------------------------------------
{
	int    i,j,bestIndex,jslider;
	double value1,value3,bestTarget,bestValue;
   FILE *SENSITY;
   FILE *GNUFILE;
	char  s[1024];
	String ^str;

	if ( MyGUIData->DataLoaded == 0 ) return;

	if     ( (GNUFILE = fopen ("SensityMulti.gp","w+") ) == NULL ) return;
	fprintf  (GNUFILE,"reset\n");
	fprintf  (GNUFILE,"set term win\n");
	fprintf  (GNUFILE,"set ylabel \"target\"\n");
	fprintf  (GNUFILE,"set xlabel \"variable value\"\n");
	fprintf  (GNUFILE,"set grid\n");
	fprintf  (GNUFILE,"#set yrange [0:10]\n");

	jslider = Get_islider();

	progressBar1->Maximum::set(jslider);
	progressBar1->Minimum::set(0);
	progressBar1->Step::set(1);

	for ( j=0; j<Numberofsliders-3; j++ )
	{
		if ( mycheckBox[j]->CheckState::get() == System::Windows::Forms::CheckState::Checked )
		{
			if ( j < 10 ) sprintf (s,"sensity0%d.dat",j);
			else          sprintf (s,"sensity%d.dat",j);

			if ( ( SENSITY = fopen (s,"w+") ) == NULL ) return;
//
// --- get base value
//
			System::Double::TryParse(mytextBox1[j]->Text,value1);
			mytextBox1[j]->BackColor = System::Drawing::Color::LightSkyBlue;		
			mytextBox1[j]->Update();
//
// --- do sensitivity analysis
//
			for ( i=0; i<jslider; i++ )
			{
 				if ( mycheckBox[j]->CheckState == System::Windows::Forms::CheckState::Checked )
				{
					value3 = value1*(0.5 + 3.0*((double) i)/((double)(jslider-1)));
					MyGUIData->MyRun->input1[j] = value3;
					MyGUIData->Evaluate();
					fprintf (SENSITY," %+12.6e %+12.6e\n",value3,MyGUIData->target);
					progressBar1->Value::set(i);

					if ( i == 0 )
					{
						bestTarget = MyGUIData->target;
						bestValue  = value3;
						bestIndex  = 0;
					}
					else
					{
						if ( bestTarget > MyGUIData->target ) 
						{
							bestTarget = MyGUIData->target;
							bestValue  = value3;
							bestIndex  = i;
						}
					}
				}
				this->Refresh();
			}

			mytextBox1[j]->BackColor = System::Drawing::Color::White; 		
			mytextBox1[j]->Update();
//
// --- drawings and reset or value 
//
			fclose (SENSITY);
			if   ( bestValues ) MyGUIData->MyRun->input1[j] = bestValue;
			else                MyGUIData->MyRun->input1[j] = value1;

			MyGUIData->Evaluate();
			MyOpenGLPlot->Draw();

			str = this->MyGUIData->strarray[j]->Trim();
			fprintf  (GNUFILE,"set title \"variable <%s> with target = %+10.4e at value = %+10.4e [%2d/%2d]\"\n",str,bestTarget,bestValue,bestIndex,jslider);
			fprintf  (GNUFILE,"plot \\\n");
			fprintf  (GNUFILE,"\"%s\" u 1:2 notitle w lp lt 1 lw 3\n",s);
			fprintf  (GNUFILE,"pause -1\n");
		}
	}
	fclose   (GNUFILE);
   this->progressBar1->Value::set(0);
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::BestValues_Click (System::Object^  sender, System::EventArgs^ e) 
//--------------------------------------------------------------------------------------------------
{
	if ( bestValues == 0 ) 
	{
		this->bestValuesToolStripMenuItem->Text = L"IgnoreBestValues";
		bestValues = 1;
	}
	else
	{
		this->bestValuesToolStripMenuItem->Text = L"UseBestValues";
		bestValues = 0;
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::Reset_Click (System::Object^  sender, System::EventArgs^ e) 
//--------------------------------------------------------------------------------------------------
{
	double value1;

   if ( currentslider < 0 || currentslider > Numberofsliders-1 ) return;

	System::Double::TryParse(mytextBox1[currentslider]->Text,value1);
	islider  = 50;
	setrange =  0;
	this->Set_rangemin(value1*0.5);
	this->Set_rangemax(value1*2.0);
	this->Set_islider (islider);
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::Ranges_Click (System::Object^  sender, System::EventArgs^ e) 
//--------------------------------------------------------------------------------------------------
{
	int    i,j;
	double value1;
	String ^string;
   System::Windows::Forms::DialogResult result;

	if ( MyGUIData->DataLoaded == 0 ) return;

	Form^    dlg      = gcnew Form;
   Button^  button1  = gcnew Button;

	System::Double::TryParse(mytextBox1[currentslider]->Text,value1);

	if ( setrange == 0 )
	{
		islider  = 50;
		this->Set_rangemin(value1*0.5);
		this->Set_rangemax(value1*2.0);
		this->Set_islider(islider);
	}

   // --- dialog box with fixed size and centered location without icon and mini/maximize fields
 	dlg->Location    = System::Drawing::Point(220,  112 );
	dlg->Size        = System::Drawing::Size( 290,  130 );
	dlg->MaximumSize = System::Drawing::Size( 290,  370 );
	dlg->MinimumSize = System::Drawing::Size( 290,  110 );
	dlg->MaximizeBox::set(false);
	dlg->MinimizeBox::set(false);
	dlg->ShowIcon::set(false);
	dlg->SizeGripStyle::set(System::Windows::Forms::SizeGripStyle::Hide);
	dlg->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
	dlg->Font = MyFont;
	dlg->Text = "SelectRanges";

   // --- ResultStepBox settings

   // --- button1 settings
   button1->Location     = System::Drawing::Point( 220, 15);
   button1->Size         = System::Drawing::Size (  50, 23);
   button1->Text         = "Close";
   button1->DialogResult = System::Windows::Forms::DialogResult::OK;

   // --- write into Box
	for ( i=0; i<3; i++ )
	{
		TextBox^ RangeBox = gcnew TextBox;

		RangeBox->Location = System::Drawing::Point(   5,  15+20*i );
		RangeBox->Size     = System::Drawing::Size ( 210,  20   );
		switch (i)
		{
			case 0: 
			{
				string = "Stepwidth Sensitivity    = " + this->Get_islider().ToString("d2");
				RangeBox->Text = string;
				break;
			}
			case 1: 
			{
				string = "upper bound Sensitivity = " + myToString(this->Get_rangemax());
				RangeBox->Text = string;
				break;
			}
			case 2: 
			{
				string = "lower bound Sensitivity = " + myToString(this->Get_rangemin());
				RangeBox->Text = string;
				break;
			}
		}
      myrangeBox[i] = RangeBox;
		dlg->Controls->Add(  myrangeBox[i] );
	}

   // --- added to the dialog box
	dlg->Controls->Add( button1 );

   // --- show the dialog box and get the dialogresult
	result = dlg->ShowDialog();
	if ( result != System::Windows::Forms::DialogResult::OK ) return;

   setrange = 1;

	string = myrangeBox[0]->Text;
	i = string->IndexOf(L"=");
	System::Int32::TryParse(string->Substring(i+1),j);
	this->Set_islider(j);

	string = myrangeBox[1]->Text;
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	this->Set_rangemax(value1);

	string = myrangeBox[2]->Text;
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	this->Set_rangemin(value1);

	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::CorneringStiffnessClick (System::Object^  sender, System::EventArgs^ e) 
//--------------------------------------------------------------------------------------------------
{
	char s [512];
   System::Windows::Forms::DialogResult    FileDialog;
	System::Windows::Forms::SaveFileDialog ^File;
	String ^File1;

   if ( MyGUIData->DataLoaded == 0 ) 
	{
		System::Windows::Forms::MessageBox::Show(" Load parameter first","Hint");
		return;
	}

   // --- file selection for solver file, set the initial values of filedialog
   File = gcnew System::Windows::Forms::SaveFileDialog;
   File->Filter  =  "CorneringStiffness (*.dat)|*.dat|All files (*.*)|*.*";
   File->FileName = "CorneringStiffness.dat";

   FileDialog = File->ShowDialog();

   // --- get the name of the selected file 
   if ( FileDialog == System::Windows::Forms::DialogResult::OK ) 
   {
      // --- get the path to the file and the solver filename
		MyGUIData->Evaluate();
		File1 = File->FileName::get();
		MyGUIData->ConvertStringToChar(File1,s);
		strcpy (MyGUIData->MyRun->DataCornerName,s);
		MyGUIData->MyRun->get_CornerKy();
   }
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::UserScale_Click (System::Object^  sender, System::EventArgs^ e) 
//--------------------------------------------------------------------------------------------------
{
	int    i;
	double value1;
	String ^string;
   System::Windows::Forms::DialogResult result;

	if ( MyOpenGLPlot->Get_UserScale() )
	{
		this->userScalingToolStripMenuItem->Text = L"UserScale";
		MyOpenGLPlot->Set_UserScale(false);
		return;
	}
	else
	{
		this->userScalingToolStripMenuItem->Text = L"AutoScale";
		MyOpenGLPlot->Set_UserScale(true);
	}

	if ( MyGUIData->DataLoaded == 0 ) return;

	Form^    dlg      = gcnew Form;
   Button^  button1  = gcnew Button;

   // --- dialog box with fixed size and centered location without icon and mini/maximize fields
 	dlg->Location    = System::Drawing::Point(220,  112 );
	dlg->Size        = System::Drawing::Size( 290,  260 );
	dlg->MaximumSize = System::Drawing::Size( 290,  370 );
	dlg->MinimumSize = System::Drawing::Size( 290,  260 );
	dlg->MaximizeBox::set(false);
	dlg->MinimizeBox::set(false);
	dlg->ShowIcon::set(false);
	dlg->SizeGripStyle::set(System::Windows::Forms::SizeGripStyle::Hide);
	dlg->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
	dlg->Font = MyFont;
	dlg->Text = "SelectRanges";

   // --- ResultStepBox settings

   // --- button1 settings
   button1->Location     = System::Drawing::Point( 220, 15);
   button1->Size         = System::Drawing::Size (  50, 23);
   button1->Text         = "Close";
   button1->DialogResult = System::Windows::Forms::DialogResult::OK;

   // --- write into Box
	for ( i=0; i<10; i++ )
	{
		TextBox^ RangeBox = gcnew TextBox;

		RangeBox->Location = System::Drawing::Point(   5,  15+20*i );
		RangeBox->Size     = System::Drawing::Size ( 210,  20   );
		switch (i)
		{
			case 0: 
			{
				value1 = MyOpenGLPlot->Get_Fxmax();
				string = "Fxmax = " + value1.ToString("f2");
				RangeBox->Text = string;
				break;
			}
			case 1: 
			{
				value1 = MyOpenGLPlot->Get_Fxmin();
				string = "Fxmin = " + value1.ToString("f2");
				RangeBox->Text = string;
				break;
			}
			case 2: 
			{
				value1 = MyOpenGLPlot->Get_Fymax();
				string = "Fymax = " + value1.ToString("f2");
				RangeBox->Text = string;
				break;
			}
			case 3: 
			{
				value1 = MyOpenGLPlot->Get_Fymin();
				string = "Fymin = " + value1.ToString("f2");
				RangeBox->Text = string;
				break;
			}
 
			case 4: 
			{
				value1 = MyOpenGLPlot->Get_sxmax();
				string = "sxmax = " + value1.ToString("f4");
				RangeBox->Text = string;
				break;
			}
			case 5: 
			{
				value1 = MyOpenGLPlot->Get_sxmin();
				string = "sxmin = " + value1.ToString("f4");
				RangeBox->Text = string;
				break;
			}
			case 6: 
			{
				value1 = MyOpenGLPlot->Get_symax();
				string = "symax = " + value1.ToString("f2");
				RangeBox->Text = string;
				break;
			}
			case 7: 
			{
				value1 = MyOpenGLPlot->Get_symin();
				string = "symin = " + value1.ToString("f2");
				RangeBox->Text = string;
				break;
			}
			case 8: 
			{
				value1 = MyOpenGLPlot->Get_TargetFmax();
				string = "TargetFmax = " + value1.ToString("f2");
				RangeBox->Text = string;
				break;
			}
			case 9: 
			{
				value1 = MyOpenGLPlot->Get_TargetPmax();
				string = "TargetPmax = " + value1.ToString("f2");
				RangeBox->Text = string;
				break;
			}
		}
      myrangeBox[i] = RangeBox;
		dlg->Controls->Add(  myrangeBox[i] );
	}

   // --- added to the dialog box
	dlg->Controls->Add( button1 );

   // --- show the dialog box and get the dialogresult
	result = dlg->ShowDialog();
	if ( result != System::Windows::Forms::DialogResult::OK ) return;


	string = myrangeBox[0]->Text;
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	MyOpenGLPlot->Set_Fxmax(value1);

	string = myrangeBox[1]->Text;
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	MyOpenGLPlot->Set_Fxmin(value1);

	string = myrangeBox[2]->Text;
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	MyOpenGLPlot->Set_Fymax(value1);

	string = myrangeBox[3]->Text;
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	MyOpenGLPlot->Set_Fymin(value1);

	string = myrangeBox[4]->Text;
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	MyOpenGLPlot->Set_sxmax(value1);

	string = myrangeBox[5]->Text;
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	MyOpenGLPlot->Set_sxmin(value1);

	string = myrangeBox[6]->Text;
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	MyOpenGLPlot->Set_symax(value1);

	string = myrangeBox[7]->Text;
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	MyOpenGLPlot->Set_symin(value1);

	string = myrangeBox[8]->Text;
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	MyOpenGLPlot->Set_TargetFmax(value1);

	string = myrangeBox[9]->Text;
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	MyOpenGLPlot->Set_TargetPmax(value1);

	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::SaveResultFiles_Click  (System::Object^  sender, System::EventArgs^ e) 
// ------------------------------------------------------------------------------------------------- 
{		
	int    i;
	double value1;

	if ( MyGUIData->DataLoaded == 0 ) return;
	for ( i=0; i<Numberofsliders; i++ )
	{
		System::Double::TryParse(mytextBox2[i]->Text,value1);
		MyGUIData->MyRun->input1[i] = value1;
	}
	MyGUIData->EvaluateAll();
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
//--------------------------------------------------------------------------------------------------
void Form1::Reset_Click () 
//--------------------------------------------------------------------------------------------------
{
	double value1;

   if ( currentslider < 0 || currentslider > Numberofsliders-1 ) return;

	System::Double::TryParse(mytextBox1[currentslider]->Text,value1);
	islider  = 50;
	setrange = 0;
	this->Set_rangemin(value1*0.5);
	this->Set_rangemax(value1*2.0);
	this->Set_islider (islider);
}
//----------------------------------------------------------------------
void Form1::HideTracks(int Numberofsliders,int CurrentNumberofsliders)
//----------------------------------------------------------------------
{
	for ( int i=Numberofsliders; i<CurrentNumberofsliders; i++ )
	{
		myLabel[i]->Hide(); 
		mytextBox[i]->Hide(); 
		mytextBox1[i]->Hide(); 
		mytextBox2[i]->Hide(); 
		mytrackBar[i]->Hide(); 
		mycheckBox[i]->Hide(); 
	}
}
//----------------------------------------------------------------------
void Form1::ShowTracks(int Numberofsliders,int CurrentNumberofsliders)
//----------------------------------------------------------------------
{
	for ( int i=Numberofsliders; i<CurrentNumberofsliders; i++ )
	{
		myLabel[i]->Show(); 
		mytextBox[i]->Show(); 
		mytextBox1[i]->Show(); 
		mytextBox2[i]->Show(); 
		mytrackBar[i]->Show(); 
		mycheckBox[i]->Show(); 
	}
}
//----------------------------------------------------------------------
void Form1::AddTrack (int istart,int Numberofsliders)
//----------------------------------------------------------------------
{
	int i;
	int ystart = 10;
	int yoff   = 25;
	int xoff   = 100;
	int scale  = 1;

	for ( i=istart; i<Numberofsliders; i++ )
	{
		localtrackBar = gcnew System::Windows::Forms::TrackBar;
		localtextBox  = gcnew System::Windows::Forms::TextBox;
		localtextBox1 = gcnew System::Windows::Forms::TextBox;
		localtextBox2 = gcnew System::Windows::Forms::TextBox;
		locallabel    = gcnew System::Windows::Forms::Label;
		localcheckBox = gcnew System::Windows::Forms::CheckBox; 

		// parameter name
		locallabel->Location = System::Drawing::Point((int)(5*scale),(int)((8+yoff*i+ystart)*scale));
		locallabel->Name = L"label1";
		locallabel->AutoEllipsis = true;
		locallabel->Size = System::Drawing::Size((int)(64*scale),(int)(17*scale));
		locallabel->Text = L"Paramter" + (i+1).ToString();
		locallabel->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif",(float)(8*scale), 
			          System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));

		// parameter base value
		localtextBox1->Location = System::Drawing::Point((int)(70*scale),(int)((5+yoff*i+ystart)*scale));
		localtextBox1->Size     = System::Drawing::Size((int)(80*scale), (int)(5*scale));
		localtextBox1->Text     = L"Paramter" + (i+1).ToString();
		localtextBox1->Name::set(i.ToString());

		// Set up the TrackBar.
		localtrackBar->Location = System::Drawing::Point((int)((xoff+55)*scale),(int)((7+yoff*i+ystart)*scale));
		localtrackBar->AutoSize = false;
		localtrackBar->Size     = System::Drawing::Size((int)(200*scale),(int)(20*scale));
		localtrackBar->Text     = i.ToString();

		// parameter design variable
		localcheckBox->Location = System::Drawing::Point((int)((xoff+260)*scale),(int)((7+yoff*i+ystart)*scale));
		localcheckBox->Size     = System::Drawing::Size((int)(20*scale),(int)(17*scale));
		localcheckBox->Checked  = false;
		localcheckBox->Name::set(i.ToString());

		// parameter slider value
		localtextBox->Location = System::Drawing::Point((int)((xoff+295)*scale),(int)((5+yoff*i+ystart)*scale));
		localtextBox->Size     = System::Drawing::Size((int)(28*scale),(int)(5*scale));
		localtextBox->Name::set(i.ToString());

		// parameter current value
		localtextBox2->Location = System::Drawing::Point((int)((xoff+330)*scale),(int)((5+yoff*i+ystart)*scale));
		localtextBox2->Size     = System::Drawing::Size((int)(80*scale),(int)(5*scale));
		localtextBox2->Text     = L"Paramter" + (i+1).ToString();
		localtextBox2->Enabled  = false;

		// Set up how the form should be displayed and add the controls to the form.
		array<System::Windows::Forms::Control^>^formControls = {this->localcheckBox,this->localtextBox,this->localtextBox1,this->localtextBox2,this->localtrackBar,this->locallabel};
		this->panel2->Controls->AddRange( formControls );
	   	   
		// The Maximum property sets the value of the track bar when
		// the slider is all the way to the right.
		localtrackBar->Maximum = 100;
		localtrackBar->Value    = 33;
	   
		// The TickFrequency property establishes how many positions
		// are between each tick-mark.
		localtrackBar->TickFrequency = 5;
	   
		// The LargeChange property sets how many positions to move
		// if the bar is clicked on either side of the slider.
		localtrackBar->LargeChange = 10;
	   
		// The SmallChange property sets how many positions to move
		// if the keyboard arrows are used to move the slider.
		localtrackBar->SmallChange = 1;

		myLabel[i]    = locallabel;
		mytextBox [i] = localtextBox;
		mytextBox1[i] = localtextBox1;
		mytextBox2[i] = localtextBox2;
		mytrackBar[i] = localtrackBar;
		mycheckBox[i] = localcheckBox;

		mytrackBar[i]->ValueChanged   += gcnew System::EventHandler(this, &Form1::localtrackBar_Scroll);
		mytrackBar[i]->Enter          += gcnew System::EventHandler(this, &Form1::localtrackBar_Enter);
		mytextBox[i]->TextChanged     += gcnew System::EventHandler(this, &Form1::localtextBox_Edit);
		mytextBox[i]->Enter           += gcnew System::EventHandler(this, &Form1::localtextBox_Enter);
		mycheckBox[i]->CheckedChanged += gcnew System::EventHandler(this, &Form1::localcheckBox_Changed);
		mytextBox1[i]->TextChanged    += gcnew System::EventHandler(this, &Form1::localtextBox_Changed);
		mytextBox1[i]->Leave          += gcnew System::EventHandler(this, &Form1::localtextBox_Leave);
		mytextBox1[i]->Enter          += gcnew System::EventHandler(this, &Form1::localtextBox_Enter);
	}
	mytextBox1[0]->BackColor = System::Drawing::Color::LightSkyBlue; 

	progressBar1->Location = System::Drawing::Point((int)(( 190)*scale),(int)((15+yoff*32+ystart)*scale));
	this->label1->Location = System::Drawing::Point((int)((  10)*scale),(int)((15+yoff*32+ystart)*scale));
}
//----------------------------------------------------------------------
void Form1::ShowTrack(int i)
//----------------------------------------------------------------------
{
	localtextBox  = mytextBox[i];
	localtrackBar = mytrackBar[i];
	localtextBox->Text = String::Concat( "", localtrackBar->Value );
}
//----------------------------------------------------------------------
void Form1::SetSlider(int i, int j)
//----------------------------------------------------------------------
{		
	if ( i < 0   ) i = 0;
	if ( i > 100 ) i = 100;
	mytrackBar[j]->Value = i;
}
//----------------------------------------------------------------------
void Form1::SetChangedValues(int i)
//----------------------------------------------------------------------
{		
	String ^str;
	double value,value1,value2;
	if ( MyGUIData->DataLoaded )
	{
		value  = (double) mytrackBar[i]->Value::get();
		str    = mytextBox1[i]->Text;
		System::Double::TryParse(str,value1);
		value2 = value1*(0.5 + 3.0*value/200.0);
		MyGUIData->MyRun->input1[i] = value2;
		mytextBox2[i]->Text = myToString(value2);
//
// --- avoid unnesseseary redrawing while slide are change due to reading data file
//
		if ( ReDrawOpenGL )
		{
			MyGUIData->Evaluate();
			MyOpenGLPlot->Draw();
		}
	}
}
//----------------------------------------------------------------------
void Form1::SetAllValues()
//----------------------------------------------------------------------
{
	int i;
	double value;

	if ( MyGUIData->DataLoaded )
	{
		for ( i=0; i<CurrentNumberofsliders; i++ )
		{
			value  = MyGUIData->MyRun->input1[i];
			mytextBox1[i]->Text = myToString(value);
			mytextBox2[i]->Text = myToString(value);
		}
//
// --- avoid unnesseseary redrawing while slide are change due to reading data file
//
		if ( ReDrawOpenGL )
		{
			MyGUIData->Evaluate();
			MyOpenGLPlot->Draw();
		}
	}
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::Form1_Activated (System::Object^  sender, System::EventArgs^ e)
// -------------------------------------------------------------------------------------------------------------
{
	if ( MyGUIData->DataLoaded == 1 ) MyOpenGLPlot->Draw ();
	else                              MyOpenGLPlot->Draw0();
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::Form1_Click  (System::Object^  sender, System::EventArgs^ e) 
// -------------------------------------------------------------------------------------------------------------
{
	if ( MyGUIData->DataLoaded == 1 ) MyOpenGLPlot->Draw();
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::Form1_Paint (System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e)
// -------------------------------------------------------------------------------------------------------------
{
	if ( MyGUIData->DataLoaded == 1 ) MyOpenGLPlot->Draw();
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::panel1_Paint (System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e)
// -------------------------------------------------------------------------------------------------------------
{
	if ( MyGUIData->DataLoaded == 1 ) MyOpenGLPlot->Draw();
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::SelectResults_Click (System::Object^  sender, System::EventArgs^  e)
// -------------------------------------------------------------------------------------------------------------
{
	String ^string;

   // ---  create the dialog box  
	Form^    dlg    = gcnew Form;

   // --- create dialog elements
   ResultStepBox   = gcnew CheckedListBox;
   Button^ button1 = gcnew Button;

   // --- dialog box with fixed size and centered location without icon and mini/maximize fields
 	dlg->Location    = System::Drawing::Point(220,  112 );
	dlg->Size        = System::Drawing::Size( 290,  200 );
	dlg->MaximumSize = System::Drawing::Size( 290,  370 );
	dlg->MinimumSize = System::Drawing::Size( 290,  200 );
	dlg->MaximizeBox::set(false);
	dlg->MinimizeBox::set(false);
	dlg->ShowIcon::set(false);
	dlg->SizeGripStyle::set(System::Windows::Forms::SizeGripStyle::Hide);
	dlg->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
	dlg->Font = MyFont;
	dlg->Text = "SelectComponents";

   // --- ResultStepBox settings
   ResultStepBox->Location = System::Drawing::Point(   5,  15 );
   ResultStepBox->Size     = System::Drawing::Size ( 200, 140 );
   ResultStepBox->Items->Clear();
   ResultStepBox->CheckOnClick = true;
   ResultStepBox->SelectionMode = SelectionMode::One;
   ResultStepBox->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::ResultStepBox_SelectedIndexChanged);

   // --- button1 settings
   button1->Location     = System::Drawing::Point( 220, 15);
   button1->Size         = System::Drawing::Size (  50, 23);
   button1->Text         = "Close";
   button1->DialogResult = System::Windows::Forms::DialogResult::OK;

   // --- write saving points into ResultStepBox

	string = "Reference Force F (Measurement)";
	if ( this->MyOpenGLPlot->Get_M() )     ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                   ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	string = "Additional Reference";
	if ( this->MyOpenGLPlot->Get_MA() )    ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                   ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	string = "Total Force F";
	if ( this->MyOpenGLPlot->Get_F() )     ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                   ResultStepBox->Items->Add(string,::CheckState::Unchecked);
                             
	string = "Sticking Force F";
	if ( this->MyOpenGLPlot->Get_FST() )   ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                   ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	string = "Sliding Force F";
	if ( this->MyOpenGLPlot->Get_FSL() )   ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                   ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	string = "Accuracy bounds";
	if ( this->MyOpenGLPlot->Get_RANGE() ) ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                   ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	string = "Plot Legend";
	if ( this->MyOpenGLPlot->Get_Files() ) ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                   ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	string = L"Track Data";
	if ( this->MyOpenGLPlot->Get_Time() )  ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                   ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	string = L"Target Function";
	if ( this->MyOpenGLPlot->Get_TargetF() )  ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                      ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	string = L"Target Values";
	if ( this->MyOpenGLPlot->Get_TargetP() )  ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                      ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	// --- added to the dialog box
	dlg->Controls->Add( ResultStepBox );
	dlg->Controls->Add( button1 );

   // --- show the dialog box and get the dialogresult
	dlg->ShowDialog();

	if ( MyGUIData->DataLoaded ) 
	{
		this->MyOpenGLPlot->DoScale();
		this->MyOpenGLPlot->Draw();
	}
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::ResultStepBox_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
// -------------------------------------------------------------------------------------------------------------
{
	int  index;
	bool checked;

	index   = this->ResultStepBox->SelectedIndex;
	checked = this->ResultStepBox->GetItemChecked(index);

	switch (index)
	{
		case 0: { if ( checked ) this->MyOpenGLPlot->Set_M      (1); else this->MyOpenGLPlot->Set_M      (0); break; }
		case 1: { if ( checked ) this->MyOpenGLPlot->Set_MA     (1); else this->MyOpenGLPlot->Set_MA     (0); break; }
		case 2: { if ( checked ) this->MyOpenGLPlot->Set_F      (1); else this->MyOpenGLPlot->Set_F      (0); break; }
		case 3: { if ( checked ) this->MyOpenGLPlot->Set_FST    (1); else this->MyOpenGLPlot->Set_FST    (0); break; }
		case 4: { if ( checked ) this->MyOpenGLPlot->Set_FSL    (1); else this->MyOpenGLPlot->Set_FSL    (0); break; }
		case 5: { if ( checked ) this->MyOpenGLPlot->Set_RANGE  (1); else this->MyOpenGLPlot->Set_RANGE  (0); break; }
		case 6: { if ( checked ) this->MyOpenGLPlot->Set_Files  (1); else this->MyOpenGLPlot->Set_Files  (0); break; }
		case 7: { if ( checked ) this->MyOpenGLPlot->Set_Time   (1); else this->MyOpenGLPlot->Set_Time   (0); break; }
		case 8: { if ( checked ) this->MyOpenGLPlot->Set_TargetF(1); else this->MyOpenGLPlot->Set_TargetF(0); break; }
		case 9: { if ( checked ) this->MyOpenGLPlot->Set_TargetP(1); else this->MyOpenGLPlot->Set_TargetP(0); break; }
		default: break; 
	}
	if ( MyGUIData->DataLoaded )
	{
		this->MyOpenGLPlot->DoScale();
		this->MyOpenGLPlot->Draw();
	}
}	
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::curveLinesWidthToolStripMenuItem_Click    (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	float  wl1,wl2,wl3,wl4,wl5,wl6,wl7,wl8;

   // ---  create the dialog box  
	Form^    dlg     = gcnew Form;

   // --- create dialog elements
	Label^   label1  = gcnew Label;
	Label^   label2  = gcnew Label;
	Label^   label3  = gcnew Label;
	Label^   label4  = gcnew Label;
	Label^   label5  = gcnew Label;
	Label^   label6  = gcnew Label;
	Label^   label7  = gcnew Label;
	Label^   label8  = gcnew Label;
   Button^  button1 = gcnew Button;

   // --- dialog box with fixed size and centered location without icon and mini/maximize fields
 	dlg->Location    = System::Drawing::Point(220,  112 );
	dlg->Size        = System::Drawing::Size( 290,  270 );
	dlg->MaximumSize = System::Drawing::Size( 290,  370 );
	dlg->MinimumSize = System::Drawing::Size( 290,  270 );
	dlg->MaximizeBox::set(false);
	dlg->MinimizeBox::set(false);
	dlg->ShowIcon::set(false);
	dlg->SizeGripStyle::set(System::Windows::Forms::SizeGripStyle::Hide);
	dlg->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
	dlg->Font = MyFont;
	dlg->Text = "SelectLineProperties";

   // --- button1 settings
   button1->Location     = System::Drawing::Point( 220, 12);
   button1->Size         = System::Drawing::Size (  50, 23);
   button1->Text         = "Close";
   button1->DialogResult = System::Windows::Forms::DialogResult::OK;

   // --- write saving points into ResultStepBox

   numericUpDown1->Location = System::Drawing::Point(  5, 25);
   numericUpDown6->Location = System::Drawing::Point(  5, 50);
   numericUpDown2->Location = System::Drawing::Point(  5, 75);
   numericUpDown3->Location = System::Drawing::Point(  5,100);
   numericUpDown4->Location = System::Drawing::Point(  5,125);
   numericUpDown5->Location = System::Drawing::Point(  5,150);
   numericUpDown7->Location = System::Drawing::Point(  5,175);
   numericUpDown8->Location = System::Drawing::Point(  5,200);
   numericUpDown1->Size     = System::Drawing::Size ( 60, 15);
   numericUpDown2->Size     = System::Drawing::Size ( 60, 15);
   numericUpDown3->Size     = System::Drawing::Size ( 60, 15);
   numericUpDown4->Size     = System::Drawing::Size ( 60, 15);
   numericUpDown5->Size     = System::Drawing::Size ( 60, 15);
   numericUpDown6->Size     = System::Drawing::Size ( 60, 15);
   numericUpDown7->Size     = System::Drawing::Size ( 60, 15);
   numericUpDown8->Size     = System::Drawing::Size ( 60, 15);

	numericUpDown1->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);
	numericUpDown2->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);
	numericUpDown3->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);
	numericUpDown4->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);
	numericUpDown5->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);
	numericUpDown6->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);
	numericUpDown7->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);
	numericUpDown8->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);

	MyOpenGLPlot->Get_LineWidth(&wl1,&wl2,&wl3,&wl4,&wl5,&wl6,&wl7,&wl8);

	numericUpDown1->Value = (int) wl1;
	numericUpDown2->Value = (int) wl2;
	numericUpDown3->Value = (int) wl3;
	numericUpDown4->Value = (int) wl4;
	numericUpDown5->Value = (int) wl5;
	numericUpDown6->Value = (int) wl6;
	numericUpDown7->Value = (int) wl7;
	numericUpDown8->Value = (int) wl8;

	label1->Location = System::Drawing::Point( 75, 25 );
	label1->Size     = System::Drawing::Size( 135, 20 );
   label1->Text     = " Reference Force F";

	label6->Location = System::Drawing::Point( 75, 50 );
	label6->Size     = System::Drawing::Size( 135, 20 );
   label6->Text     = " Additional Reference";	 
																 
	label2->Location = System::Drawing::Point( 75, 75 );
	label2->Size     = System::Drawing::Size( 135, 20 );
   label2->Text     = " Total Force F    ";		 
																 
	label3->Location = System::Drawing::Point( 75,100 );
	label3->Size     = System::Drawing::Size( 135, 20 );
   label3->Text     = " Sticking Force F ";		 
																 
	label4->Location = System::Drawing::Point( 75,125 );
	label4->Size     = System::Drawing::Size( 135, 20 );
   label4->Text     = " Sliding Force F  ";

	label5->Location = System::Drawing::Point( 75,150 );
	label5->Size     = System::Drawing::Size( 135, 20 );
   label5->Text     = " Accuracy Width ";

	label7->Location = System::Drawing::Point( 75,175 );
	label7->Size     = System::Drawing::Size( 135, 20 );
   label7->Text     = " Target Function ";

	label8->Location = System::Drawing::Point( 75,200 );
	label8->Size     = System::Drawing::Size( 135, 20 );
   label8->Text     = " Target Point ";

   // --- added to the dialog box
	dlg->Controls->Add( label1 );
	dlg->Controls->Add( label2 );
	dlg->Controls->Add( label3 ); 
	dlg->Controls->Add( label4 );
	dlg->Controls->Add( label5 );
	dlg->Controls->Add( label6 );
	dlg->Controls->Add( label7 );
	dlg->Controls->Add( label8 );
	dlg->Controls->Add( numericUpDown1 );
	dlg->Controls->Add( numericUpDown2 );
	dlg->Controls->Add( numericUpDown3 );
	dlg->Controls->Add( numericUpDown4 );
	dlg->Controls->Add( numericUpDown5 );
	dlg->Controls->Add( numericUpDown6 );
	dlg->Controls->Add( numericUpDown7 );
	dlg->Controls->Add( numericUpDown8 );
	dlg->Controls->Add( button1 );

   // --- show the dialog box and get the dialogresult
	dlg->ShowDialog();

	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::numericUpDownTextChanged(System::Object^  sender, System::EventArgs^  e)
// -------------------------------------------------------------------------------------------------------------
{
	float  wl1,wl2,wl3,wl4,wl5,wl6,wl7,wl8;

	wl1 = (float) numericUpDown1->Value::get();
	wl2 = (float) numericUpDown2->Value::get();
	wl3 = (float) numericUpDown3->Value::get();
	wl4 = (float) numericUpDown4->Value::get();  
	wl5 = (float) numericUpDown5->Value::get();  
	wl6 = (float) numericUpDown6->Value::get();  
	wl7 = (float) numericUpDown7->Value::get();  
	wl8 = (float) numericUpDown8->Value::get();  

	MyOpenGLPlot->Set_LineWidth(wl1,wl2,wl3,wl4,wl5,wl6,wl7,wl8);

	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}	
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTarget_Click(System::Object^  sender, System::EventArgs^  e)
// ----------------------------------------------------------------------------------------------------------------
{
	int     i,index;
	String ^string;
	array<String^>^dirs;

   if ( MyGUIData->DataLoaded == 0 ) 
	{
		System::Windows::Forms::MessageBox::Show(" Load parameter first","Hint");
		return;
	}

   // ---  create the dialog elements 
	Form^    dlg       = gcnew Form;
   FxBox              = gcnew ListBox;
   FyBox              = gcnew ListBox;
   Files              = gcnew ListBox;
   Button^ button1    = gcnew Button;
   Button^ button2    = gcnew Button;
   Button^ button3    = gcnew Button;
   Button^ button4    = gcnew Button;
   Button^ button5    = gcnew Button;
   Button^ button6    = gcnew Button;
	Label^  label1     = gcnew Label;
	Label^  label2     = gcnew Label;
	Label^  label3     = gcnew Label;
	Label^  label4     = gcnew Label;
	Label^  label5     = gcnew Label;
	
	// --- dialog box with fixed size and centered location without icon and mini/maximize fields
 	dlg->Location    = System::Drawing::Point(220,  112 );
	dlg->Size        = System::Drawing::Size( 480,  320 );
	dlg->MaximumSize = System::Drawing::Size( 490,  370 );
	dlg->MinimumSize = System::Drawing::Size( 290,  170 );
	dlg->MaximizeBox::set(false);
	dlg->MinimizeBox::set(false);
	dlg->ShowIcon::set(false);
	dlg->SizeGripStyle::set(System::Windows::Forms::SizeGripStyle::Hide);
	dlg->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
	dlg->Font = MyFont;
	dlg->Text = "SelectReferenceDataFiles";

	label1->Location = System::Drawing::Point(  5,  5 );
	label1->Size     = System::Drawing::Size( 100, 20 );
	label1->Text     = "DataFiles";

	label2->Location = System::Drawing::Point(265,  5 );
	label2->Size     = System::Drawing::Size( 100, 20 );
   label2->Text     = L"Selected Fx";

	label3->Location = System::Drawing::Point(265,135 );
	label3->Size     = System::Drawing::Size( 100, 20 );
   label3->Text     = L"Selected Fy";

	label4->Location = System::Drawing::Point(350,262 );
	label4->Size     = System::Drawing::Size(  30, 20 );
   label4->Text     = L"VT =";

	label5->Location = System::Drawing::Point(240,262 );
	label5->Size     = System::Drawing::Size(  55, 20 );
   label5->Text     = L"extension";

   Files->Location = System::Drawing::Point(   5,  20 );
   Files->Size     = System::Drawing::Size ( 200, 225 );
   Files->Items->Clear();
	Files->ScrollAlwaysVisible = true;
	Files->SelectionMode = SelectionMode::MultiExtended;

   FxBox->Location = System::Drawing::Point( 265,  20 );
   FxBox->Size     = System::Drawing::Size ( 200, 100 );
   FxBox->Items->Clear();
	FxBox->Sorted   = true;
	FxBox->ScrollAlwaysVisible = true;
	FxBox->SelectionMode = SelectionMode::MultiExtended;

   FyBox->Location = System::Drawing::Point( 265, 150 );
   FyBox->Size     = System::Drawing::Size ( 200, 100 );
   FyBox->Items->Clear();
	FyBox->Sorted   = true;
	FyBox->ScrollAlwaysVisible = true;
	FyBox->SelectionMode = SelectionMode::MultiExtended;

   // --- button1 settings
   button1->Location     = System::Drawing::Point( 217, 50);
   button1->Size         = System::Drawing::Size (  40, 23);
   button1->Text         = "Add";
	button1->Click        += gcnew System::EventHandler(this, &Form1::BuildTarget_AddFx); 

   button2->Location     = System::Drawing::Point( 217, 75);
   button2->Size         = System::Drawing::Size (  40, 23);
   button2->Text         = "Del";
	button2->Click        += gcnew System::EventHandler(this, &Form1::BuildTarget_DelFx); 

   button3->Location     = System::Drawing::Point( 217,170);
   button3->Size         = System::Drawing::Size (  40, 23);
   button3->Text         = "Add";
	button3->Click        += gcnew System::EventHandler(this, &Form1::BuildTarget_AddFy); 

   button4->Location     = System::Drawing::Point( 217,195);
   button4->Size         = System::Drawing::Size (  40, 23);
   button4->Text         = "Del";
	button4->Click        += gcnew System::EventHandler(this, &Form1::BuildTarget_DelFy); 

   button5->Location     = System::Drawing::Point(   5,257);
   button5->Size         = System::Drawing::Size ( 120, 23);
   button5->Text         = "create new target file";
 	button5->Click        += gcnew System::EventHandler(this, &Form1::StoreTargetFile); 
  
	button6->Location     = System::Drawing::Point( 130,257);
   button6->Size         = System::Drawing::Size ( 100, 23);
   button6->Text         = "load target file";
 	button6->Click        += gcnew System::EventHandler(this, &Form1::LoadTargetFile); 

   vtbox->Location     = System::Drawing::Point( 385,260);
   vtbox->Size         = System::Drawing::Size (  80, 20);
   vtbox->Text         = "16666";

   extension->Location = System::Drawing::Point( 299,260);
   extension->Size     = System::Drawing::Size ( 40, 20);
   extension->Text     = "*.dat";
	extension->Leave   += gcnew System::EventHandler(this, &Form1::BuildTarget_Extension);

	dlg->Controls->Add( Files );
	dlg->Controls->Add( FxBox );
	dlg->Controls->Add( FyBox );
	dlg->Controls->Add( button1 );
	dlg->Controls->Add( button2 );
	dlg->Controls->Add( button3 );
	dlg->Controls->Add( button4 );
	dlg->Controls->Add( button5 );
	dlg->Controls->Add( button6 );
	dlg->Controls->Add( label1 );
	dlg->Controls->Add( label2 );
	dlg->Controls->Add( label3 );
	dlg->Controls->Add( label4 );
	dlg->Controls->Add( label5 );
	dlg->Controls->Add( vtbox );
	dlg->Controls->Add( extension );

	string = MyGUIData->ConvertCharToString(MyGUIData->MyRun->WorkDirectory);
	dirs   = Directory::GetFiles(string,extension->Text);
	for (i=0; i<dirs->Length; i++ )
	{
		index = dirs[i]->LastIndexOf("\\");
		Files->Items->Add(dirs[i]->Substring(index+1));
	}

   dlg->ShowDialog();
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::LoadTargetFile (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	int   direction;
	FILE *INPUTNAME;
	double VT;
	char  s [1024];
	char  s2[1024];
	char *s1;
   System::Windows::Forms::DialogResult    FileDialog;
	System::Windows::Forms::OpenFileDialog ^ParameterFile;
	String ^File1;

   // --- file selection for solver file, set the initial values of filedialog
   ParameterFile = gcnew System::Windows::Forms::OpenFileDialog;
   ParameterFile->Filter  =  "target file (*.dat)|*.dat|All files (*.*)|*.*";
   ParameterFile->FileName = "DesignTarget.dat";

   FileDialog = ParameterFile->ShowDialog();

   // --- get the name of filedialog and extract the path and the filename of solver file
   if ( FileDialog == System::Windows::Forms::DialogResult::OK ) 
   {
      // --- get the path to the file and the solver filename
		File1 = ParameterFile->FileName::get();
		sprintf (s,"%s",File1);
   }
	if ( ( INPUTNAME = fopen (s,"r+")) == NULL ) return;
//
// --- read target file and prepare Fx and Fy list
//
   fgets ( s,1024,INPUTNAME );
   fgets ( s,1024,INPUTNAME );
//
// --- read number of data files
//
   while ( fgets ( s,1024,INPUTNAME ) )
   {
		if ( strstr ( s,"[Eof]") ) break;
      s1 = strstr ( s,"=" ) + 1;
		sscanf ( s1,"%s",s2);
		s1 = strstr ( s1,"=" ) + 1;
		s1 = strstr ( s1,"=" ) + 1;
		sscanf ( s1,"%d",&direction);
		s1 = strstr ( s1,"=" ) + 1;
		sscanf ( s1,"%lf",&VT);
		if      ( direction == 1 ) FxBox->Items->Add(MyGUIData->ConvertCharToString(s2));
		else if ( direction == 2 ) FyBox->Items->Add(MyGUIData->ConvertCharToString(s2));
		vtbox->Text = myToString(VT);
   }
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTarget_Extension (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	int     i,index;
	String ^string;
	array<String^>^dirs;

	string = MyGUIData->ConvertCharToString(MyGUIData->MyRun->WorkDirectory);
	dirs   = Directory::GetFiles(string,extension->Text);
	Files->Items->Clear();
	for (i=0; i<dirs->Length; i++ )
	{
		index = dirs[i]->LastIndexOf("\\");
		Files->Items->Add(dirs[i]->Substring(index+1));
	}
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTarget_AddFx (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Collections::IEnumerator ^num;

	if  ( Files->SelectedItems->Count == 1 ) FxBox->Items->Add(Files->Text);
	else
	{
		num = Files->SelectedItems->GetEnumerator();
		while ( num->MoveNext() ) FxBox->Items->Add(num->Current::get());
	}
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTarget_DelFx (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	if  ( FxBox->SelectedItems->Count > 0 ) FxBox->Items->RemoveAt(FxBox->SelectedIndex);
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTarget_AddFy (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Collections::IEnumerator ^num;

	if  ( Files->SelectedItems->Count == 1 ) FyBox->Items->Add(Files->Text);
	else
	{
		num = Files->SelectedItems->GetEnumerator();
		while ( num->MoveNext() ) FyBox->Items->Add(num->Current::get());
	}
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTarget_DelFy (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	if  ( FyBox->SelectedItems->Count > 0 ) FyBox->Items->RemoveAt(FyBox->SelectedIndex);
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::StoreTargetFile (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	int   i,j,ivalue,entries;
	FILE *OUTPUT;
	FILE *DATA;
	char s [1024];
   System::Windows::Forms::DialogResult    FileDialog;
	System::Windows::Forms::SaveFileDialog ^ParameterFile;
	String ^File1;
	String ^string;

   // --- file selection for solver file, set the initial values of filedialog
   ParameterFile = gcnew System::Windows::Forms::SaveFileDialog;
   ParameterFile->Filter  =  "target file (*.dat)|*.dat|All files (*.*)|*.*";
   ParameterFile->FileName = "DesignTargetNew.dat";

   FileDialog = ParameterFile->ShowDialog();

   // --- get the name of filedialog and extract the path and the filename of solver file
   if ( FileDialog == System::Windows::Forms::DialogResult::OK ) 
   {
      // --- get the path to the file and the solver filename
		File1 = ParameterFile->FileName::get();
		sprintf (MyGUIData->MyRun->OptiFileName,"%s",File1);
   }
	if ( ( OUTPUT = fopen (MyGUIData->MyRun->OptiFileName,"w+")) == NULL ) return; 
//
// --- header of design target file
// 
	fprintf (OUTPUT,"[DataFileName and Size]\n");
	fprintf (OUTPUT,"Number of Files = %d\n",FxBox->Items->Count::get()+FyBox->Items->Count::get());
	entries = FxBox->Items->Count::get();
//
// --- analyse files for longitudinal direction
//
	j = 1;
	entries = FxBox->Items->Count::get();
	for (i=0; i<entries; i++)
	{
		FxBox->ClearSelected();
		FxBox->SetSelected(i,true);
		File1 = MyGUIData->ConvertCharToString(MyGUIData->MyRun->WorkDirectory) + FxBox->Text;
		MyGUIData->ConvertStringToChar(File1,s);
		if ( ( DATA = fopen (s,"r+")) == NULL ) return; 
		ivalue = 0;
		while ( fgets (s,1024,DATA) ) {ivalue++;}
		string = vtbox->Text->Replace(",",".");
		fprintf (OUTPUT,"Datafile%d = %s Size = %d dir = 1 VT = %s \n",j,FxBox->Text,ivalue,string);
		fclose(DATA);
		j++;
	}
//
// --- analyse files for lateral direction
//
	entries = FyBox->Items->Count::get();
	for (i=0; i<entries; i++)
	{
		FyBox->ClearSelected();
		FyBox->SetSelected(i,true);
		File1 = MyGUIData->ConvertCharToString(MyGUIData->MyRun->WorkDirectory) + FyBox->Text;
		MyGUIData->ConvertStringToChar(File1,s);
		if ( ( DATA = fopen (s,"r+")) == NULL ) return; 
		ivalue = 0;
		while ( fgets (s,1024,DATA) ) {ivalue++;}
		string = vtbox->Text->Replace(",",".");
		fprintf (OUTPUT,"Datafile%d = %s Size = %d dir = 2 VT = %s \n",j,FyBox->Text,ivalue,string);
		fclose(DATA);
		j++;
	}
	fprintf (OUTPUT,"[Eof]\n");
	fclose(OUTPUT);
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTargetFromMF (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	int i;

	System::Windows::Forms::DataGridView          ^Table;
	System::Windows::Forms::DataGridViewCellStyle ^dataGridViewCellStyle;
	System::Windows::Forms::DataGridViewCellStyle ^dataGridViewCellStyle1;
	System::Data::DataTable ^dt;
   System::Data::DataRow   ^dr;
   array<String^> ^TableColumns;
	Form^ dlg              = gcnew Form;
	Table                  = gcnew System::Windows::Forms::DataGridView();
	dataGridViewCellStyle  = gcnew System::Windows::Forms::DataGridViewCellStyle();
	dataGridViewCellStyle1 = gcnew System::Windows::Forms::DataGridViewCellStyle();

	// --- dialog box with fixed size and centered location without icon and mini/maximize fields
 	dlg->Location    = System::Drawing::Point(220,  112 );
	dlg->Size        = System::Drawing::Size( 620,  329 );
	dlg->MaximumSize = System::Drawing::Size( 620,  360 );
	dlg->MinimumSize = System::Drawing::Size( 620,  329 );
	dlg->MaximizeBox::set(false);
	dlg->MinimizeBox::set(false);
	dlg->ShowIcon::set(false);
	dlg->SizeGripStyle::set(System::Windows::Forms::SizeGripStyle::Hide);
	dlg->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
	dlg->Font = MyFont;
	dlg->Text = "RunMFParameter";

   dt = gcnew DataTable();

	RowNumber    = Get_RowNumber();
	ColumnNumber = Get_ColumnNumber();

   TableColumns = gcnew array<String^>(ColumnNumber);
   
   TableColumns[ 0] = "wheel load [N]";
   TableColumns[ 1] = "slip max   [%]";
   TableColumns[ 2] = "yaw  max   [deg]";
   TableColumns[ 3] = "camber     [deg]";
	TableColumns[ 4] = "# of points";
	TableColumns[ 5] = "activate";

	for (i=0; i<ColumnNumber; i++)
   {
      dt->Columns->Add( gcnew DataColumn(TableColumns[i]));
   }
// --- fill in data

   for (i=0; i<RowNumber; i++)
   {
      dr = dt->NewRow();
		dr[TableColumns[0]] = MyGUIData->MyMF->Array_FZ[i];    
		dr[TableColumns[1]] = MyGUIData->MyMF->Array_SL[i][0];
		dr[TableColumns[2]] = MyGUIData->MyMF->Array_SA[i][0];
		dr[TableColumns[3]] = MyGUIData->MyMF->Array_CA[i];
		dr[TableColumns[4]] = MyGUIData->MyMF->Array_NU[i];	
		dr[TableColumns[5]] = MyGUIData->MyMF->Array_AC[i];	

      dt->Rows->Add(dr);
   }

// --- point to table

	Table->AllowUserToAddRows = false;
	Table->AllowUserToDeleteRows = false;
	Table->AllowUserToResizeRows = false;
	Table->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((
		(System::Windows::Forms::AnchorStyles::Top 
		| System::Windows::Forms::AnchorStyles::Bottom) 
		| System::Windows::Forms::AnchorStyles::Left) 
		| System::Windows::Forms::AnchorStyles::Right));

	dataGridViewCellStyle->ForeColor = System::Drawing::SystemColors::WindowText;
	dataGridViewCellStyle->SelectionBackColor = System::Drawing::SystemColors::Highlight;
	dataGridViewCellStyle->SelectionForeColor = System::Drawing::SystemColors::HighlightText;
	dataGridViewCellStyle->WrapMode = System::Windows::Forms::DataGridViewTriState::True;
	dataGridViewCellStyle->Alignment = System::Windows::Forms::DataGridViewContentAlignment::MiddleCenter;
	dataGridViewCellStyle->BackColor = System::Drawing::SystemColors::Window;
	dataGridViewCellStyle->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8, System::Drawing::FontStyle::Regular, 
		System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));

	dataGridViewCellStyle1->ForeColor = System::Drawing::SystemColors::InfoText;
	dataGridViewCellStyle1->WrapMode = System::Windows::Forms::DataGridViewTriState::True;
	dataGridViewCellStyle1->Alignment = System::Windows::Forms::DataGridViewContentAlignment::MiddleCenter;
	dataGridViewCellStyle1->BackColor = System::Drawing::SystemColors::Control;
	dataGridViewCellStyle1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8, System::Drawing::FontStyle::Regular, 
		System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));

	Table->ColumnHeadersDefaultCellStyle = dataGridViewCellStyle1;
	Table->DefaultCellStyle = dataGridViewCellStyle;
	Table->ColumnHeadersHeightSizeMode = System::Windows::Forms::DataGridViewColumnHeadersHeightSizeMode::AutoSize;
	Table->RowHeadersWidthSizeMode = System::Windows::Forms::DataGridViewRowHeadersWidthSizeMode::AutoSizeToDisplayedHeaders;
	Table->EditMode = System::Windows::Forms::DataGridViewEditMode::EditOnEnter;
	Table->Location = System::Drawing::Point(5, 10);
	Table->Name = L"Table";
	Table->RowHeadersVisible = false;
	Table->RowHeadersWidthSizeMode = System::Windows::Forms::DataGridViewRowHeadersWidthSizeMode::AutoSizeToDisplayedHeaders;
	Table->Size = System::Drawing::Size(600, 300);
	Table->TabIndex = 0;
	Table->CellValueChanged += gcnew System::Windows::Forms::DataGridViewCellEventHandler(this, &Form1::Table_CellValueChanged);

   Table->DataSource = dt; 
	Table->AutoResizeColumns();

	dlg->Controls->Add( Table );
   dlg->ShowDialog();
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::Table_CellValueChanged (System::Object^  sender, DataGridViewCellEventArgs^ e)
// ----------------------------------------------------------------------------------------------------------------
{
	int i,j;
	String ^string;

	System::Windows::Forms::DataGridView  ^localtable;
	localtable = (System::Windows::Forms::DataGridView^) sender;
	i = localtable->CurrentCellAddress.X::get();
	j = localtable->CurrentCellAddress.Y::get();
	string = localtable->CurrentCell->Value->ToString();
	string = string->Replace(".",",");

	switch (i)
	{
		case 0 : {MyGUIData->MyMF->Array_FZ[j]     = Convert::ToDouble(string);  break;}
		case 1 : {MyGUIData->MyMF->Array_SL[j][0]  = Convert::ToDouble(string);  break;}
		case 2 : {MyGUIData->MyMF->Array_SA[j][0]  = Convert::ToDouble(string);  break;}
		case 3 : {MyGUIData->MyMF->Array_CA[j]     = Convert::ToDouble(string);  break;}
		case 4 : {MyGUIData->MyMF->Array_NU[j]     = Convert::ToInt32(string);   break;}
		case 5 : {MyGUIData->MyMF->Array_AC[j]     = Convert::ToInt32(string);   break;}
	}
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::RunTargetFromMF (System::Object^  sender, System::EventArgs^ e)		
// ----------------------------------------------------------------------------------------------------------------
{
	int i;

	if ( MFDataLoaded == 0 ) 
	{
		System::Windows::Forms::MessageBox::Show(" Load MF parameter first","Hint");
		return;
	}
//
// --- compute results
//
	for (i=0; i<NWheelLoads; i++ )
	{
		if ( MyGUIData->MyMF->Array_AC[i] == 1 ) 
		{
			MyGUIData->MyMF->calc_Fx   (MyGUIData->MyMF->Array_NU[i],i);
			MyGUIData->MyMF->calc_FyMz (MyGUIData->MyMF->Array_NU[i],i);
			
		}
	}
	MyGUIData->MyMF->write_values();
//
// --- display results
//
	MyGUIData->File3 = L"TargetMF.dat";
	MyOpenGLPlot->Set_FileName3(MyGUIData->File3 );
	sprintf (MyGUIData->MyRun->OptiFileName,"TargetMF.dat");
	MyGUIData->LoadData(0);
	MyGUIData->GetData();
	SetAllValues();
 
	MyOpenGLPlot->Set_MeaData (MyGUIData->MyRun->Get_Optidata());
	MyOpenGLPlot->Set_SimData (MyGUIData->MyRun->Get_Simdata ());
	MyOpenGLPlot->Set_MeainfoD(MyGUIData->MyRun->Get_MeainfoD());
	MyOpenGLPlot->Set_MeainfoN(MyGUIData->MyRun->Get_MeainfoN());   
	MyOpenGLPlot->Set_MeainfoF(MyGUIData->MyRun->Get_MeainfoF());  
	MyOpenGLPlot->Draw();
	this->label1->Text = L"TargetValue = " + MyGUIData->MyRun->targetvalue.ToString("f6");
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::ColorDialog_Click (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_Background(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::referenceColorToolStripMenuItem_Click     (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_MeaForce(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::additionalColorToolStripMenuItem_Click     (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_AdditForce(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::totalForceColorToolStripMenuItem_Click    (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_SimForce(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::stickingForceColorToolStripMenuItem_Click (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_FSTForce(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::slidingForceColorToolStripMenuItem_Click  (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_FSLForce(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::AccuracyBoundsColor_Click  (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_RangeForce(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::targetFunctionColor_Click(System::Object^  sender, System::EventArgs^ e) 
// -------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_TargetF(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::targetPointColor_Click(System::Object^  sender, System::EventArgs^ e) 
// -------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_TargetP(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw();
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::AboutToolStrip_Click(System::Object^  sender, System::EventArgs^  e)
// -------------------------------------------------------------------------------------------------------------
{
	bool         bvalue;
	Form^        dlg          = gcnew Form;
	Label^       label1       = gcnew Label;
	Label^       label2       = gcnew Label;
	Label^       label3       = gcnew Label;
	Label^       label4       = gcnew Label;
	PictureBox^  pictureBox1  = gcnew PictureBox;
	Bitmap^      MyImage;

	bvalue = false;
	if ( File::Exists(L"app.ico") )
	{
		MyImage = gcnew Bitmap( L"app.ico" );
		pictureBox1->Location = System::Drawing::Point(10,20);
		pictureBox1->Name = L"pictureBox1";
		pictureBox1->Size = System::Drawing::Size(40,40);
		pictureBox1->Image = dynamic_cast<Image^>(MyImage);
		bvalue = true;
	}

   // --- create dialog elements

   // --- dialog box with fixed size and centered location without icon and mini/maximize fields
 	dlg->Location    = System::Drawing::Point(220,  112 );
   dlg->Size        = System::Drawing::Size( 340,  170 );
	dlg->MaximumSize = System::Drawing::Size( 340,  360 );
	dlg->MinimumSize = System::Drawing::Size( 340,  160 );
	dlg->MaximizeBox::set(false);
	dlg->MinimizeBox::set(false);
	dlg->ShowIcon::set(false);
	dlg->SizeGripStyle::set(System::Windows::Forms::SizeGripStyle::Hide);
	dlg->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
	dlg->Font = MyFont;
	dlg->Text = "Information";
	dlg->BackColor::set(System::Drawing::Color::LightGray);

	label1->Location = System::Drawing::Point( 55, 15 );
	label1->Size     = System::Drawing::Size( 315, 20 );
	label1->Text     = "RMOD-K Formula GUI Version 2.07 from 05.04.2021 ";

	label2->Location = System::Drawing::Point( 55, 40 );
	label2->Size     = System::Drawing::Size( 255, 20 );
   label2->Text     = L"RMOD-K FormulaVersion 2.07 from 05.04.2021 ";

	label3->Location = System::Drawing::Point( 55, 65 );
	label3->Size     = System::Drawing::Size( 255, 20 );
   label3->Text     = L"Copyright IAT Dynamics 05.04.2021 ";

	label4->Location = System::Drawing::Point( 55, 90 );
	label4->Size     = System::Drawing::Size( 255, 20 );
   label4->Text     = L"Further Information www.rmod-k.com";

   // --- added to the dialog box
	dlg->Controls->Add( label1 );
	dlg->Controls->Add( label2 );
	dlg->Controls->Add( label3 );
	dlg->Controls->Add( label4 );
	if ( bvalue ) dlg->Controls->Add( pictureBox1 );
   dlg->ShowDialog();

	if ( MyGUIData->DataLoaded ) MyOpenGLPlot->Draw();
}
// -------------------------------------------------------------------------------------
System::Void Form1::OpenHelpToolStrip_Click(System::Object^  sender, System::EventArgs^  e)
// -------------------------------------------------------------------------------------
// open help file if OpenHelpToolStrip clicked
// -------------------------------------------------------------------------------------
{
	String ^string;

	string = L"GUI.chm";
   Help::ShowHelp(this,string);
}
// -------------------------------------------------------------------------------------
System::Void Form1::SetPathOptimisation_Click  (System::Object^  sender, System::EventArgs^ e)
// -------------------------------------------------------------------------------------
{
   System::Windows::Forms::DialogResult result;

   FolderBrowserDialogBox = gcnew(System::Windows::Forms::FolderBrowserDialog);
   FolderBrowserDialogBox->SelectedPath = MyGUIData->ConvertCharToString(MyGUIData->MyRun->WorkDirectory);

   result = FolderBrowserDialogBox->ShowDialog();
   
   if ( result == System::Windows::Forms::DialogResult::OK )
   {
      MyGUIData->Optipath = FolderBrowserDialogBox->SelectedPath::get();
		Optipath = 1;
		this->selectFileToolStripMenuItem->Enabled = true;
   }
	if ( MyGUIData->DataLoaded == 1 ) MyOpenGLPlot->Draw();
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::LoadOptiMethod_Click (System::Object^  sender, System::EventArgs^ e)
// ----------------------------------------------------------------------------------------------------------------
{
   if ( MyGUIData->LoadOptiMethod() ) 
	{
		Optimethod = 1;
		this->runMatlabToolStripMenuItem->Enabled = true;
		this->runToolStripMenuItem->Enabled = true;
	}
	if ( MyGUIData->DataLoaded == 1 ) MyOpenGLPlot->Draw();
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::RunOptimisation_Scilab_Click (System::Object^  sender, System::EventArgs^ e)
// ----------------------------------------------------------------------------------------------------------------
{
	if ( Optipath   == 0 ) { System::Windows::Forms::MessageBox::Show(" Select optimisation path first","Hint");   return; }
	if ( Optimethod == 0 ) { System::Windows::Forms::MessageBox::Show(" Select optimisation method first","Hint"); return; }

	System::Threading::Thread^ newThread = gcnew System::Threading::Thread( gcnew System::Threading::ThreadStart( Do_Opti_Scilab ) );
   newThread->Start();
	if ( MyGUIData->DataLoaded == 1 ) MyOpenGLPlot->Draw();
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::RunOptimisation_Matlab_Click (System::Object^  sender, System::EventArgs^ e)
// ----------------------------------------------------------------------------------------------------------------
{
	if ( Optipath   == 0 ) { System::Windows::Forms::MessageBox::Show(" Select optimisation path first","Hint");   return; }
	if ( Optimethod == 0 ) { System::Windows::Forms::MessageBox::Show(" Select optimisation method first","Hint"); return; }

	System::Threading::Thread^ newThread = gcnew System::Threading::Thread( gcnew System::Threading::ThreadStart( Do_Opti_Matlab ) );
   newThread->Start();
	if ( MyGUIData->DataLoaded == 1 ) MyOpenGLPlot->Draw();
}
// ----------------------------------------------------------------------------------------------------------------
void Form1::Do_Opti_Scilab() 
// ----------------------------------------------------------------------------------------------------------------
{
	char s[512];
   FILE *SCIFILE;
   
	if ( MyGUIData->DataLoaded == 0 ) 
	{
		System::Windows::Forms::MessageBox::Show(" Load parameter first","Hint");
		return;
	}

   sprintf (s,"wscilex.exe -e \"cd %s; exec(\'%s\\%s\',-1); exit;\" ",MyGUIData->Optipath,MyGUIData->Optipath,MyGUIData->OptiMethodFile);
	system(s);

   if (   ( SCIFILE = fopen ("Scirun.bat","w")) == NULL ) return;
   fprintf (SCIFILE,"%s",s);
   fclose  (SCIFILE);
}
// ----------------------------------------------------------------------------------------------------------------
void Form1::Do_Opti_Matlab() 
// ----------------------------------------------------------------------------------------------------------------
{
	char s[512];
	FILE *MATFILE;
   
	if ( MyGUIData->DataLoaded == 0 ) 
	{
		System::Windows::Forms::MessageBox::Show(" Load parameter first","Hint");
		return;
	}

	if ( ( MATFILE = fopen ("runopti.m","w+") ) == NULL ) return;

	MyGUIData->OptiMethodFile = MyGUIData->OptiMethodFile->Replace(".m","");
	fprintf (MATFILE,"cd (\'%s\') \n",MyGUIData->Optipath);
   fprintf (MATFILE,"run %s \n",MyGUIData->OptiMethodFile);
   fprintf (MATFILE,"exit \n");
	fclose(MATFILE);
   sprintf (s," matlab -r runopti ",MyGUIData->Optipath);
	system(s);
}
// -------------------------------------------------------------------------------------
System::Void Form1::MainWindowSizeChange (System::Object^ sender, System::EventArgs^ e)
// -------------------------------------------------------------------------------------
{
	int   i,pwidth,pheigth;
	float xscale,yscale;
//
// ---  get current graphics window size and redraw at new size
//
	pwidth  = (int) (800.0*theWidth /1400.0);
	pheigth = (int) (800.0*theHeight/ 900.0);

	MyOpenGLPlot->DestroyGLWindow();
	MyOpenGLPlot->CreateGLWindow(pwidth,pheigth);

	return;

	System::Windows::Forms::Form  ^localform;
	System::Drawing::Point        pvalue1;
	System::Drawing::Point        pvalue2;
	System::Drawing::Point        pvalue3;
	System::Drawing::Size         svalue;

	localform = (System::Windows::Forms::Form^) sender;

	svalue = localform->Size::get();
	xscale = ((float) svalue.Width )/((float) theWidth);
	yscale = ((float) svalue.Height)/((float) theHeight);

	theWidth  = svalue.Width;
	theHeight = svalue.Height;

	SuspendLayout();
//
// --- prescale
//
	for ( i=0; i<Numberofsliders; i++ ) 
	{
		myLabel[i]->Scale(   xscale,yscale); 
		mytextBox [i]->Scale(xscale,yscale);
		mytextBox1[i]->Scale(xscale,yscale);
		mytextBox2[i]->Scale(xscale,yscale);
		mytrackBar[i]->Scale(xscale,yscale);
		mycheckBox[i]->Scale(xscale,yscale);
	}

	label1->Scale(      xscale,yscale);
	label2->Scale(      xscale,yscale);
	label3->Scale(      xscale,yscale);
	label4->Scale(      xscale,yscale);
	label5->Scale(      xscale,yscale);
	label6->Scale(      xscale,yscale);
	label7->Scale(      xscale,yscale);
	label8->Scale(      xscale,yscale);
	panel1->Scale(      xscale,yscale);
	progressBar1->Scale(xscale,yscale);
//
// --- force a common size
//
	svalue = myLabel[0]->Size;
	if ( svalue.Width  > 64 ) svalue.Width  = 64;
	if ( svalue.Height > 17 ) svalue.Height = 17;
	if ( svalue.Height <  2 ) svalue.Height = 17;
	for ( i=0; i<Numberofsliders; i++ ) myLabel[i]->Size = svalue;

	svalue = mytextBox[0]->Size;
	if ( svalue.Width  > 28 ) svalue.Width  = 28;
	if ( svalue.Height >  5 ) svalue.Height =  5;
	if ( svalue.Height <  2 ) svalue.Height =  5;
	for ( i=0; i<Numberofsliders; i++ ) mytextBox[i]->Size = svalue;

	svalue = mytextBox1[0]->Size;
	if ( svalue.Width  > 80 ) svalue.Width  = 80;
	if ( svalue.Height >  5 ) svalue.Height =  5;
	if ( svalue.Height <  2 ) svalue.Height =  5;
	for ( i=0; i<Numberofsliders; i++ ) mytextBox1[i]->Size = svalue;

	svalue = mytextBox2[0]->Size;
	if ( svalue.Width  > 80 ) svalue.Width  = 80;
	if ( svalue.Height >  5 ) svalue.Height =  5;
	if ( svalue.Height <  2 ) svalue.Height =  5;
	for ( i=0; i<Numberofsliders; i++ ) mytextBox2[i]->Size = svalue;

	svalue = mytrackBar[0]->Size;
	if ( svalue.Height <  20 ) svalue.Height =  20;
	if ( svalue.Width  > 200 ) svalue.Width  = 200;
	if ( svalue.Height >  20 ) svalue.Height =  20;
	for ( i=0; i<Numberofsliders; i++ ) mytrackBar[i]->Size = svalue;

	svalue = mycheckBox[0]->Size;
	if ( svalue.Width  > 20 ) svalue.Width  = 20;
	if ( svalue.Height <  2 ) svalue.Height = 17;
	if ( svalue.Height > 17 ) svalue.Height = 17;
	for ( i=0; i<Numberofsliders; i++ ) mycheckBox[i]->Size = svalue;
//
// --- force a common position
//
	pvalue1 = myLabel[0]->Location; 
	pvalue2 = myLabel[1]->Location;

	if ( pvalue2.Y - pvalue1.Y > 25 ) pvalue2.Y = pvalue1.Y + 25;
	if ( pvalue2.Y - pvalue1.Y <  5 ) pvalue2.Y = pvalue1.Y +  5;

	for ( i=0; i<Numberofsliders; i++ ) 
	{
		pvalue3 = myLabel[i]->Location;
		pvalue3.Y = pvalue1.Y + i*(pvalue2.Y-pvalue1.Y);
		myLabel[i]->Location = pvalue3;

		pvalue3 = mytextBox[i]->Location;
		pvalue3.Y = pvalue1.Y + i*(pvalue2.Y-pvalue1.Y);
		mytextBox[i]->Location = pvalue3;

		pvalue3 = mytextBox1[i]->Location;
		pvalue3.Y = pvalue1.Y + i*(pvalue2.Y-pvalue1.Y);
		mytextBox1[i]->Location = pvalue3;

		pvalue3 = mytextBox2[i]->Location;
		pvalue3.Y = pvalue1.Y + i*(pvalue2.Y-pvalue1.Y);
		mytextBox2[i]->Location = pvalue3;;

		pvalue3 = mytrackBar[i]->Location;
		pvalue3.Y = pvalue1.Y + i*(pvalue2.Y-pvalue1.Y);
		mytrackBar[i]->Location = pvalue3;

		pvalue3 = mycheckBox[i]->Location;
		pvalue3.Y = pvalue1.Y + i*(pvalue2.Y-pvalue1.Y);
		mycheckBox[i]->Location = pvalue3;
	}

	pvalue3 = label1->Location;
	pvalue3.Y = pvalue1.Y + (i+1)*(pvalue2.Y-pvalue1.Y);
	pvalue3.X = pvalue1.X;
	label1->Location = pvalue3;

	pvalue3 = progressBar1->Location;
	pvalue3.Y = pvalue1.Y + (i+1)*(pvalue2.Y-pvalue1.Y);
	pvalue3.X = pvalue1.X;
	progressBar1->Location = pvalue3;
	svalue = progressBar1->Size;
	if ( svalue.Width  > 372 ) svalue.Height =  372;
	if ( svalue.Width  <  20 ) svalue.Height =  272;
	if ( svalue.Height >  12 ) svalue.Height =   12;
	if ( svalue.Height <   2 ) svalue.Height =   12;
	progressBar1->Size = svalue;

	ResumeLayout();
}
// -------------------------------------------------------------------------------------
String ^Form1::myToString (double value)  
// -------------------------------------------------------------------------------------
{
	if ( fabs(value) < 10000.0 && fabs(value) > 0.0001 ) return (value.ToString("f6"));
	else                                                 return (value.ToString("e5"));
}
} 