#pragma once
#include "OpenGLPlot.h"
#include "FormulaGUIData.h"
#include "FormulaDefines.h"

namespace FormulaGUI {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			Nmodelparameter201     = 33; 
			Numberofsliders        = 44;
			CurrentNumberofsliders = 44;
			InitializeComponent();
//			LOGFILE = fopen ("Logfile.dat","w+");
			MyGUIData->set_Nmodelparameter (Nmodelparameter201);
			MyGUIData->MyRun->Set_NModelPar(Nmodelparameter201);
			MyGUIData->MyRun->Set_Logfile(LOGFILE);
			AddTrack(0,Numberofsliders);
			HideTracks(CurrentNumberofsliders,Numberofsliders);
			for (int i=0; i<Numberofsliders; i++ ) ShowTrack(i);
			MyOpenGLPlot = gcnew COpenGLPlot(this->panel1,plotwidth,plotheigth);
			MyOpenGLPlot->Set_Logfile(LOGFILE);
			MyOpenGLPlot->ReSizeGL(plotwidth,plotheigth);
			MyOpenGLPlot->Draw0();
			this->Update();
			currentslider =  0;
			rangemin      =  0.5;
			rangemax      =  2.0;
			setrange      =  0;
			islider       = 50;
			bestValues    =  0;
         scicalled     =  0;
			Optipath      =  0;
			Optimethod    =  0;
			RowNumber     =  NWheelLoads;
			ColumnNumber  =  6;
			MFDataLoaded  =  0;
			ReDrawOpenGL  =  1;
			theWidth      = 1400.0;
			theHeight     =  900.0;
			MyFont        = gcnew System::Drawing::Font(L"Microsoft Sans Serif", 7, System::Drawing::FontStyle::Regular);
		} 

	protected:
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	public:  void ShowTrack        (int i);
				void SetChangedValues (int i);
				void SetAllValues     ();
				void SetSlider        (int i, int j);
				void AddTrack         (int Numberofsliders, int CurrentNumberofsliders);
				void HideTracks       (int Numberofsliders, int CurrentNumberofsliders);
				void ShowTracks       (int Numberofsliders, int CurrentNumberofsliders);
				void Reset_Click      ();
     static void Do_Opti_Scilab   ();
     static void Do_Opti_Matlab   ();

	private: System::ComponentModel::IContainer            ^components;
            System::Windows::Forms::FolderBrowserDialog   ^FolderBrowserDialogBox;
				System::Windows::Forms::ProgressBar           ^progressBar1;
				System::Windows::Forms::TrackBar              ^localtrackBar;
				System::Windows::Forms::TextBox               ^localtextBox;
				System::Windows::Forms::TextBox               ^localtextBox1;
				System::Windows::Forms::TextBox               ^localtextBox2;
				System::Windows::Forms::TextBox               ^RangeBox;
				System::Windows::Forms::ListBox               ^FxBox;
				System::Windows::Forms::ListBox               ^FyBox;
				System::Windows::Forms::ListBox               ^Files;
	         System::Windows::Forms::Panel                 ^panel1;
				System::Windows::Forms::Panel                 ^panel2;
				System::Windows::Forms::Label                 ^locallabel;
				System::Windows::Forms::Label                 ^label1;
				System::Windows::Forms::Label                 ^label2;
				System::Windows::Forms::Label                 ^label3;
				System::Windows::Forms::Label                 ^label4;
				System::Windows::Forms::Label                 ^label5;
				System::Windows::Forms::Label                 ^label6;
				System::Windows::Forms::Label                 ^label7;
				System::Windows::Forms::Label                 ^label8;
				System::Windows::Forms::Label                 ^label9;
				System::Windows::Forms::CheckBox              ^localcheckBox;
				System::Windows::Forms::CheckedListBox        ^ResultStepBox;
				System::Windows::Forms::MenuStrip             ^menuStrip1;
				System::Windows::Forms::ToolStripMenuItem     ^HelpMenue;
				System::Windows::Forms::ToolStripMenuItem     ^toolStripMenuItem1;
				System::Windows::Forms::ToolStripMenuItem     ^LoadReferenceFile;
	         System::Windows::Forms::ToolStripMenuItem     ^LoadParameterFile;
				System::Windows::Forms::ToolStripMenuItem     ^SaveParameterFile;
			   System::Windows::Forms::ToolStripMenuItem     ^SaveResultFiles;
				System::Windows::Forms::ToolStripMenuItem     ^utilitiesToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^backgroundColorToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^curveColorsToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^slidingForceColorToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^stickingForceColorToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^totalForceColorToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^referenceColorToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^curveLinesWidthToolStripMenuItem;
		      System::Windows::Forms::ToolStripMenuItem     ^drawToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^AboutToolStrip;
			   System::Windows::Forms::ToolStripMenuItem     ^OpenHelpToolStrip;
				System::Windows::Forms::ToolStripMenuItem     ^analysisToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^designSensitivityToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^sensitivityOptionsToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^rangesToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^fullSensitivityToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^bestValuesToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^resetToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^buildTargetToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^accuracyBoundsColorToolStripMenuItem;
            System::Windows::Forms::ToolStripMenuItem     ^optimisationToolStripMenuItem;
            System::Windows::Forms::ToolStripMenuItem     ^setPathToolStripMenuItem;
            System::Windows::Forms::ToolStripMenuItem     ^runToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^runMatlabToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^selectFileToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^buildTargetFromMFToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^loadMFDataFileToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^runTargetFromMFToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^userScalingToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^saveGraphicsToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^corneringStiffnessToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^additionalReferenceToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^selectedSensitivityToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^tagetFunctionColotToolStripMenuItem;
				System::Windows::Forms::ToolStripMenuItem     ^targetPointColorToolStripMenuItem;

				static array<System::Windows::Forms::Label^>    ^myLabel    = gcnew array<System::Windows::Forms::Label^>   (NUMBEROFSLIDERS);
				static array<System::Windows::Forms::TextBox^>  ^mytextBox  = gcnew array<System::Windows::Forms::TextBox^> (NUMBEROFSLIDERS);
				static array<System::Windows::Forms::TextBox^>  ^mytextBox1 = gcnew array<System::Windows::Forms::TextBox^> (NUMBEROFSLIDERS);
				static array<System::Windows::Forms::TextBox^>  ^mytextBox2 = gcnew array<System::Windows::Forms::TextBox^> (NUMBEROFSLIDERS);
				static array<System::Windows::Forms::TrackBar^> ^mytrackBar = gcnew array<System::Windows::Forms::TrackBar^>(NUMBEROFSLIDERS);
				static array<System::Windows::Forms::CheckBox^> ^mycheckBox = gcnew array<System::Windows::Forms::CheckBox^>(NUMBEROFSLIDERS);
				static array<System::Windows::Forms::TextBox^>  ^myrangeBox = gcnew array<System::Windows::Forms::TextBox^>(10);

				System::Drawing::Font ^MyFont;

			   static CFormulaGUIData ^MyGUIData    = gcnew CFormulaGUIData() ;
				static NumericUpDown^ numericUpDown1 = gcnew NumericUpDown;
				static NumericUpDown^ numericUpDown2 = gcnew NumericUpDown;
				static NumericUpDown^ numericUpDown3 = gcnew NumericUpDown;
				static NumericUpDown^ numericUpDown4 = gcnew NumericUpDown;
				static NumericUpDown^ numericUpDown5 = gcnew NumericUpDown;
				static NumericUpDown^ numericUpDown6 = gcnew NumericUpDown;
				static NumericUpDown^ numericUpDown7 = gcnew NumericUpDown;
				static NumericUpDown^ numericUpDown8 = gcnew NumericUpDown;
				static TextBox^       vtbox          = gcnew TextBox;
				static TextBox^       extension      = gcnew TextBox;

				static COpenGLPlot     ^MyOpenGLPlot;
            FILE                   *LOGFILE;

				int     currentslider,islider,setrange,bestValues,scicalled; 
				int     ColumnNumber,RowNumber,MFDataLoaded,ReDrawOpenGL;	  
				int     Nmodelparameter201,Numberofsliders,CurrentNumberofsliders;
				int     Optipath,Optimethod;
				double  rangemin,rangemax,theWidth,theHeight;

				inline void Set_rangemin    (double value) {rangemin      =  value;};
				inline void Set_rangemax    (double value) {rangemax      =  value;};
				inline void Set_islider     (int   ivalue) {islider       = ivalue;};
				inline void Set_ColumnNumber(int   ivalue) {ColumnNumber  = ivalue;};
				inline void Set_RowNumber   (int   ivalue) {RowNumber     = ivalue;};

				inline double Get_rangemin    () {return rangemin;};
				inline double Get_rangemax    () {return rangemax;};
				inline int    Get_islider     () {return islider;};
				inline int    Get_ColumnNumber() {return ColumnNumber;};
				inline int    Get_RowNumber   () {return RowNumber;};

#pragma region Windows Form Designer generated code
		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
			this->menuStrip1 = (gcnew System::Windows::Forms::MenuStrip());
			this->toolStripMenuItem1 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->LoadParameterFile = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->LoadReferenceFile = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->loadMFDataFileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->SaveParameterFile = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->SaveResultFiles = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->utilitiesToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->backgroundColorToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->curveColorsToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->referenceColorToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->additionalReferenceToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->totalForceColorToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->stickingForceColorToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->slidingForceColorToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->accuracyBoundsColorToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->curveLinesWidthToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->drawToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->userScalingToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->buildTargetToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->buildTargetFromMFToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->runTargetFromMFToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->saveGraphicsToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->analysisToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->designSensitivityToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->fullSensitivityToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->selectedSensitivityToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->sensitivityOptionsToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->rangesToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->resetToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->bestValuesToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->corneringStiffnessToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->optimisationToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->setPathToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->selectFileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->runToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->runMatlabToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->HelpMenue = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->AboutToolStrip = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->OpenHelpToolStrip = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->panel1 = (gcnew System::Windows::Forms::Panel());
			this->panel2 = (gcnew System::Windows::Forms::Panel());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->label8 = (gcnew System::Windows::Forms::Label());
			this->label9 = (gcnew System::Windows::Forms::Label());
			this->progressBar1 = (gcnew System::Windows::Forms::ProgressBar());
			this->tagetFunctionColotToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->targetPointColorToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuStrip1->SuspendLayout();
			this->SuspendLayout();
			// 
			// menuStrip1
			// 
			this->menuStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(5) {this->toolStripMenuItem1, 
				this->utilitiesToolStripMenuItem, this->analysisToolStripMenuItem, this->optimisationToolStripMenuItem, this->HelpMenue});
			this->menuStrip1->LayoutStyle = System::Windows::Forms::ToolStripLayoutStyle::HorizontalStackWithOverflow;
			this->menuStrip1->Location = System::Drawing::Point(0, 0);
			this->menuStrip1->Name = L"menuStrip1";
			this->menuStrip1->Size = System::Drawing::Size(1380, 24);
			this->menuStrip1->TabIndex = 1;
			this->menuStrip1->Text = L"menuStrip1";
			// 
			// toolStripMenuItem1
			// 
			this->toolStripMenuItem1->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(5) {this->LoadParameterFile, 
				this->LoadReferenceFile, this->loadMFDataFileToolStripMenuItem, this->SaveParameterFile, this->SaveResultFiles});
			this->toolStripMenuItem1->Name = L"toolStripMenuItem1";
			this->toolStripMenuItem1->Size = System::Drawing::Size(42, 20);
			this->toolStripMenuItem1->Text = L"Files";
			// 
			// LoadParameterFile
			// 
			this->LoadParameterFile->Name = L"LoadParameterFile";
			this->LoadParameterFile->Size = System::Drawing::Size(178, 22);
			this->LoadParameterFile->Text = L"LoadParameter";
			this->LoadParameterFile->Click += gcnew System::EventHandler(this, &Form1::LoadParameterFile_Click);
			// 
			// LoadReferenceFile
			// 
			this->LoadReferenceFile->Name = L"LoadReferenceFile";
			this->LoadReferenceFile->Size = System::Drawing::Size(178, 22);
			this->LoadReferenceFile->Text = L"LoadMeasurements";
			this->LoadReferenceFile->Click += gcnew System::EventHandler(this, &Form1::LoadReferenceFile_Click);
			// 
			// loadMFDataFileToolStripMenuItem
			// 
			this->loadMFDataFileToolStripMenuItem->Name = L"loadMFDataFileToolStripMenuItem";
			this->loadMFDataFileToolStripMenuItem->Size = System::Drawing::Size(178, 22);
			this->loadMFDataFileToolStripMenuItem->Text = L"LoadMFDataFile";
			this->loadMFDataFileToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::LoadMFDataFile);
			// 
			// SaveParameterFile
			// 
			this->SaveParameterFile->Name = L"SaveParameterFile";
			this->SaveParameterFile->Size = System::Drawing::Size(178, 22);
			this->SaveParameterFile->Text = L"SaveParameter";
			this->SaveParameterFile->Click += gcnew System::EventHandler(this, &Form1::SaveParameterFile_Click);
			// 
			// SaveResultFiles
			// 
			this->SaveResultFiles->Name = L"SaveResultFiles";
			this->SaveResultFiles->Size = System::Drawing::Size(178, 22);
			this->SaveResultFiles->Text = L"SaveResults";
			this->SaveResultFiles->Click += gcnew System::EventHandler(this, &Form1::SaveResultFiles_Click);
			// 
			// utilitiesToolStripMenuItem
			// 
			this->utilitiesToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(9) {this->backgroundColorToolStripMenuItem, 
				this->curveColorsToolStripMenuItem, this->curveLinesWidthToolStripMenuItem, this->drawToolStripMenuItem, this->userScalingToolStripMenuItem, 
				this->buildTargetToolStripMenuItem, this->buildTargetFromMFToolStripMenuItem, this->runTargetFromMFToolStripMenuItem, this->saveGraphicsToolStripMenuItem});
			this->utilitiesToolStripMenuItem->Name = L"utilitiesToolStripMenuItem";
			this->utilitiesToolStripMenuItem->Size = System::Drawing::Size(58, 20);
			this->utilitiesToolStripMenuItem->Text = L"Utilities";
			// 
			// backgroundColorToolStripMenuItem
			// 
			this->backgroundColorToolStripMenuItem->Name = L"backgroundColorToolStripMenuItem";
			this->backgroundColorToolStripMenuItem->Size = System::Drawing::Size(187, 22);
			this->backgroundColorToolStripMenuItem->Text = L"BackgroundColor";
			this->backgroundColorToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::ColorDialog_Click);
			// 
			// curveColorsToolStripMenuItem
			// 
			this->curveColorsToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(8) {this->referenceColorToolStripMenuItem, 
				this->additionalReferenceToolStripMenuItem, this->totalForceColorToolStripMenuItem, this->stickingForceColorToolStripMenuItem, 
				this->slidingForceColorToolStripMenuItem, this->accuracyBoundsColorToolStripMenuItem, this->tagetFunctionColotToolStripMenuItem, 
				this->targetPointColorToolStripMenuItem});
			this->curveColorsToolStripMenuItem->Name = L"curveColorsToolStripMenuItem";
			this->curveColorsToolStripMenuItem->Size = System::Drawing::Size(187, 22);
			this->curveColorsToolStripMenuItem->Text = L"CurveColor";
			// 
			// referenceColorToolStripMenuItem
			// 
			this->referenceColorToolStripMenuItem->Name = L"referenceColorToolStripMenuItem";
			this->referenceColorToolStripMenuItem->Size = System::Drawing::Size(192, 22);
			this->referenceColorToolStripMenuItem->Text = L"ReferenceForceColor";
			this->referenceColorToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::referenceColorToolStripMenuItem_Click);
			// 
			// additionalReferenceToolStripMenuItem
			// 
			this->additionalReferenceToolStripMenuItem->Name = L"additionalReferenceToolStripMenuItem";
			this->additionalReferenceToolStripMenuItem->Size = System::Drawing::Size(192, 22);
			this->additionalReferenceToolStripMenuItem->Text = L"AdditionalReference";
			this->additionalReferenceToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::additionalColorToolStripMenuItem_Click);
			// 
			// totalForceColorToolStripMenuItem
			// 
			this->totalForceColorToolStripMenuItem->Name = L"totalForceColorToolStripMenuItem";
			this->totalForceColorToolStripMenuItem->Size = System::Drawing::Size(192, 22);
			this->totalForceColorToolStripMenuItem->Text = L"TotalForceColor";
			this->totalForceColorToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::totalForceColorToolStripMenuItem_Click);
			// 
			// stickingForceColorToolStripMenuItem
			// 
			this->stickingForceColorToolStripMenuItem->Name = L"stickingForceColorToolStripMenuItem";
			this->stickingForceColorToolStripMenuItem->Size = System::Drawing::Size(192, 22);
			this->stickingForceColorToolStripMenuItem->Text = L"StickingForceColor";
			this->stickingForceColorToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::stickingForceColorToolStripMenuItem_Click);
			// 
			// slidingForceColorToolStripMenuItem
			// 
			this->slidingForceColorToolStripMenuItem->Name = L"slidingForceColorToolStripMenuItem";
			this->slidingForceColorToolStripMenuItem->Size = System::Drawing::Size(192, 22);
			this->slidingForceColorToolStripMenuItem->Text = L"SlidingForceColor";
			this->slidingForceColorToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::slidingForceColorToolStripMenuItem_Click);
			// 
			// accuracyBoundsColorToolStripMenuItem
			// 
			this->accuracyBoundsColorToolStripMenuItem->Name = L"accuracyBoundsColorToolStripMenuItem";
			this->accuracyBoundsColorToolStripMenuItem->Size = System::Drawing::Size(192, 22);
			this->accuracyBoundsColorToolStripMenuItem->Text = L"AccuracyBoundsColor";
			this->accuracyBoundsColorToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::AccuracyBoundsColor_Click);
			// 
			// curveLinesWidthToolStripMenuItem
			// 
			this->curveLinesWidthToolStripMenuItem->Name = L"curveLinesWidthToolStripMenuItem";
			this->curveLinesWidthToolStripMenuItem->Size = System::Drawing::Size(187, 22);
			this->curveLinesWidthToolStripMenuItem->Text = L"LineProperties";
			this->curveLinesWidthToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::curveLinesWidthToolStripMenuItem_Click);
			// 
			// drawToolStripMenuItem
			// 
			this->drawToolStripMenuItem->Name = L"drawToolStripMenuItem";
			this->drawToolStripMenuItem->Size = System::Drawing::Size(187, 22);
			this->drawToolStripMenuItem->Text = L"Visibility";
			this->drawToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::SelectResults_Click);
			// 
			// userScalingToolStripMenuItem
			// 
			this->userScalingToolStripMenuItem->Name = L"userScalingToolStripMenuItem";
			this->userScalingToolStripMenuItem->Size = System::Drawing::Size(187, 22);
			this->userScalingToolStripMenuItem->Text = L"UserScaling";
			this->userScalingToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::UserScale_Click);
			// 
			// buildTargetToolStripMenuItem
			// 
			this->buildTargetToolStripMenuItem->Name = L"buildTargetToolStripMenuItem";
			this->buildTargetToolStripMenuItem->Size = System::Drawing::Size(187, 22);
			this->buildTargetToolStripMenuItem->Text = L"BuildTarget";
			this->buildTargetToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::BuildTarget_Click);
			// 
			// buildTargetFromMFToolStripMenuItem
			// 
			this->buildTargetFromMFToolStripMenuItem->Name = L"buildTargetFromMFToolStripMenuItem";
			this->buildTargetFromMFToolStripMenuItem->Size = System::Drawing::Size(187, 22);
			this->buildTargetFromMFToolStripMenuItem->Text = L"DefineTargetFromMF";
			this->buildTargetFromMFToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::BuildTargetFromMF);
			// 
			// runTargetFromMFToolStripMenuItem
			// 
			this->runTargetFromMFToolStripMenuItem->Name = L"runTargetFromMFToolStripMenuItem";
			this->runTargetFromMFToolStripMenuItem->Size = System::Drawing::Size(187, 22);
			this->runTargetFromMFToolStripMenuItem->Text = L"RunTargetFromMF";
			this->runTargetFromMFToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::RunTargetFromMF);
			// 
			// saveGraphicsToolStripMenuItem
			// 
			this->saveGraphicsToolStripMenuItem->Name = L"saveGraphicsToolStripMenuItem";
			this->saveGraphicsToolStripMenuItem->Size = System::Drawing::Size(187, 22);
			this->saveGraphicsToolStripMenuItem->Text = L"SaveGraphics";
			this->saveGraphicsToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::SaveGraphis_Click);
			// 
			// analysisToolStripMenuItem
			// 
			this->analysisToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(5) {this->designSensitivityToolStripMenuItem, 
				this->fullSensitivityToolStripMenuItem, this->selectedSensitivityToolStripMenuItem, this->sensitivityOptionsToolStripMenuItem, 
				this->corneringStiffnessToolStripMenuItem});
			this->analysisToolStripMenuItem->Name = L"analysisToolStripMenuItem";
			this->analysisToolStripMenuItem->Size = System::Drawing::Size(62, 20);
			this->analysisToolStripMenuItem->Text = L"Analysis";
			// 
			// designSensitivityToolStripMenuItem
			// 
			this->designSensitivityToolStripMenuItem->Name = L"designSensitivityToolStripMenuItem";
			this->designSensitivityToolStripMenuItem->Size = System::Drawing::Size(171, 22);
			this->designSensitivityToolStripMenuItem->Text = L"DesignSensitivity";
			this->designSensitivityToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::Sensitivity_Click);
			// 
			// fullSensitivityToolStripMenuItem
			// 
			this->fullSensitivityToolStripMenuItem->Name = L"fullSensitivityToolStripMenuItem";
			this->fullSensitivityToolStripMenuItem->Size = System::Drawing::Size(171, 22);
			this->fullSensitivityToolStripMenuItem->Text = L"FullSensitivity";
			this->fullSensitivityToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::SensitivityAll_Click);
			// 
			// selectedSensitivityToolStripMenuItem
			// 
			this->selectedSensitivityToolStripMenuItem->Name = L"selectedSensitivityToolStripMenuItem";
			this->selectedSensitivityToolStripMenuItem->Size = System::Drawing::Size(171, 22);
			this->selectedSensitivityToolStripMenuItem->Text = L"SelectedSensitivity";
			this->selectedSensitivityToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::SensitivityAllSelected_Click);
			// 
			// sensitivityOptionsToolStripMenuItem
			// 
			this->sensitivityOptionsToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {this->rangesToolStripMenuItem, 
				this->resetToolStripMenuItem, this->bestValuesToolStripMenuItem});
			this->sensitivityOptionsToolStripMenuItem->Name = L"sensitivityOptionsToolStripMenuItem";
			this->sensitivityOptionsToolStripMenuItem->Size = System::Drawing::Size(171, 22);
			this->sensitivityOptionsToolStripMenuItem->Text = L"SensitivityOptions";
			// 
			// rangesToolStripMenuItem
			// 
			this->rangesToolStripMenuItem->Name = L"rangesToolStripMenuItem";
			this->rangesToolStripMenuItem->Size = System::Drawing::Size(164, 22);
			this->rangesToolStripMenuItem->Text = L"Ranges";
			this->rangesToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::Ranges_Click);
			// 
			// resetToolStripMenuItem
			// 
			this->resetToolStripMenuItem->Name = L"resetToolStripMenuItem";
			this->resetToolStripMenuItem->Size = System::Drawing::Size(164, 22);
			this->resetToolStripMenuItem->Text = L"Reset";
			this->resetToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::Reset_Click);
			// 
			// bestValuesToolStripMenuItem
			// 
			this->bestValuesToolStripMenuItem->Name = L"bestValuesToolStripMenuItem";
			this->bestValuesToolStripMenuItem->Size = System::Drawing::Size(164, 22);
			this->bestValuesToolStripMenuItem->Text = L"IgnoreBestValues";
			this->bestValuesToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::BestValues_Click);
			// 
			// corneringStiffnessToolStripMenuItem
			// 
			this->corneringStiffnessToolStripMenuItem->Name = L"corneringStiffnessToolStripMenuItem";
			this->corneringStiffnessToolStripMenuItem->Size = System::Drawing::Size(171, 22);
			this->corneringStiffnessToolStripMenuItem->Text = L"CorneringStiffness";
			this->corneringStiffnessToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::CorneringStiffnessClick);
			// 
			// optimisationToolStripMenuItem
			// 
			this->optimisationToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(4) {this->setPathToolStripMenuItem, 
				this->selectFileToolStripMenuItem, this->runToolStripMenuItem, this->runMatlabToolStripMenuItem});
			this->optimisationToolStripMenuItem->Name = L"optimisationToolStripMenuItem";
			this->optimisationToolStripMenuItem->Size = System::Drawing::Size(88, 20);
			this->optimisationToolStripMenuItem->Text = L"Optimisation";
			// 
			// setPathToolStripMenuItem
			// 
			this->setPathToolStripMenuItem->Name = L"setPathToolStripMenuItem";
			this->setPathToolStripMenuItem->Size = System::Drawing::Size(147, 22);
			this->setPathToolStripMenuItem->Text = L"SetPath";
			this->setPathToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::SetPathOptimisation_Click);
			// 
			// selectFileToolStripMenuItem
			// 
			this->selectFileToolStripMenuItem->Enabled = false;
			this->selectFileToolStripMenuItem->Name = L"selectFileToolStripMenuItem";
			this->selectFileToolStripMenuItem->Size = System::Drawing::Size(147, 22);
			this->selectFileToolStripMenuItem->Text = L"SelectMethod";
			this->selectFileToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::LoadOptiMethod_Click);
			// 
			// runToolStripMenuItem
			// 
			this->runToolStripMenuItem->Enabled = false;
			this->runToolStripMenuItem->Name = L"runToolStripMenuItem";
			this->runToolStripMenuItem->Size = System::Drawing::Size(147, 22);
			this->runToolStripMenuItem->Text = L"Run Scilab";
			this->runToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::RunOptimisation_Scilab_Click);
			// 
			// runMatlabToolStripMenuItem
			// 
			this->runMatlabToolStripMenuItem->Enabled = false;
			this->runMatlabToolStripMenuItem->Name = L"runMatlabToolStripMenuItem";
			this->runMatlabToolStripMenuItem->Size = System::Drawing::Size(147, 22);
			this->runMatlabToolStripMenuItem->Text = L"Run Matlab";
			this->runMatlabToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::RunOptimisation_Matlab_Click);
			// 
			// HelpMenue
			// 
			this->HelpMenue->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->AboutToolStrip, 
				this->OpenHelpToolStrip});
			this->HelpMenue->Name = L"HelpMenue";
			this->HelpMenue->Size = System::Drawing::Size(44, 20);
			this->HelpMenue->Text = L"Help";
			// 
			// AboutToolStrip
			// 
			this->AboutToolStrip->Name = L"AboutToolStrip";
			this->AboutToolStrip->Size = System::Drawing::Size(131, 22);
			this->AboutToolStrip->Text = L"About";
			this->AboutToolStrip->Click += gcnew System::EventHandler(this, &Form1::AboutToolStrip_Click);
			// 
			// OpenHelpToolStrip
			// 
			this->OpenHelpToolStrip->Name = L"OpenHelpToolStrip";
			this->OpenHelpToolStrip->Size = System::Drawing::Size(131, 22);
			this->OpenHelpToolStrip->Text = L"Open Help";
			this->OpenHelpToolStrip->Click += gcnew System::EventHandler(this, &Form1::OpenHelpToolStrip_Click);
			// 
			// panel1
			// 
			this->panel1->Location = System::Drawing::Point(550, 54);
			this->panel1->Name = L"panel1";
			this->panel1->Size = System::Drawing::Size(800, 800);
			this->panel1->TabIndex = 2;
			this->panel1->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &Form1::panel1_Paint);
			// 
			// panel2
			// 
			this->panel2->AutoScroll = true;
			this->panel2->AutoSizeMode = System::Windows::Forms::AutoSizeMode::GrowAndShrink;
			this->panel2->Location = System::Drawing::Point(12, 57);
			this->panel2->Name = L"panel2";
			this->panel2->Size = System::Drawing::Size(532, 758);
			this->panel2->TabIndex = 3;
			// 
			// label1
			// 
			this->label1->Location = System::Drawing::Point(5, 840);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(171, 23);
			this->label1->TabIndex = 3;
			this->label1->Text = L"TargetValue";
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(5, 29);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(35, 13);
			this->label2->TabIndex = 4;
			this->label2->Text = L"Name";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(100, 29);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(34, 13);
			this->label3->TabIndex = 5;
			this->label3->Text = L"Value";
			// 
			// label4
			// 
			this->label4->AutoEllipsis = true;
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(200, 29);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(86, 13);
			this->label4->TabIndex = 6;
			this->label4->Text = L"1/2 < Range < 2";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(390, 29);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(44, 13);
			this->label5->TabIndex = 7;
			this->label5->Text = L"Change";
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(440, 29);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(70, 13);
			this->label6->TabIndex = 8;
			this->label6->Text = L"Value*Range";
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Location = System::Drawing::Point(340, 29);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(42, 13);
			this->label7->TabIndex = 10;
			this->label7->Text = L"DesVar";
			this->label7->TextAlign = System::Drawing::ContentAlignment::TopCenter;
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Location = System::Drawing::Point(550, 29);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(190, 13);
			this->label8->TabIndex = 11;
			this->label8->Text = L"DataFileName";
			this->label8->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->Location = System::Drawing::Point(850, 29);
			this->label9->Name = L"label9";
			this->label9->Size = System::Drawing::Size(74, 13);
			this->label9->TabIndex = 11;
			this->label9->Text = L"Version";
			this->label9->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// progressBar1
			// 
			this->progressBar1->Location = System::Drawing::Point(164, 842);
			this->progressBar1->Name = L"progressBar1";
			this->progressBar1->Size = System::Drawing::Size(272, 12);
			this->progressBar1->TabIndex = 9;
			// 
			// tagetFunctionColotToolStripMenuItem
			// 
			this->tagetFunctionColotToolStripMenuItem->Name = L"tagetFunctionColotToolStripMenuItem";
			this->tagetFunctionColotToolStripMenuItem->Size = System::Drawing::Size(192, 22);
			this->tagetFunctionColotToolStripMenuItem->Text = L"TargetFunctionColor";
			this->tagetFunctionColotToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::targetFunctionColor_Click);
			// 
			// targetPointColorToolStripMenuItem
			// 
			this->targetPointColorToolStripMenuItem->Name = L"targetPointColorToolStripMenuItem";
			this->targetPointColorToolStripMenuItem->Size = System::Drawing::Size(192, 22);
			this->targetPointColorToolStripMenuItem->Text = L"TargetPointColor";
			this->targetPointColorToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::targetPointColor_Click);
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->AutoScroll = true;
			this->ClientSize = System::Drawing::Size(1380, 900);
			this->Controls->Add(this->panel2);
			this->Controls->Add(this->label9);
			this->Controls->Add(this->label8);
			this->Controls->Add(this->label7);
			this->Controls->Add(this->label6);
			this->Controls->Add(this->label5);
			this->Controls->Add(this->label4);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->panel1);
			this->Controls->Add(this->menuStrip1);
			this->Controls->Add(this->progressBar1);
			this->HelpButton = true;
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->MainMenuStrip = this->menuStrip1;
			this->Name = L"Form1";
			this->SizeGripStyle = System::Windows::Forms::SizeGripStyle::Show;
			this->Text = L"RMOD-K Formula GUI";
			this->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &Form1::Form1_Paint);
			this->SizeChanged += gcnew System::EventHandler(this, &Form1::MainWindowSizeChange);
			this->Activated += gcnew System::EventHandler(this, &Form1::Form1_Activated);
			this->Click += gcnew System::EventHandler(this, &Form1::Form1_Click);
			this->Resize += gcnew System::EventHandler(this, &Form1::MainWindowSizeChange);
			this->menuStrip1->ResumeLayout(false);
			this->menuStrip1->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

      String ^Form1::myToString (double value); 

private: 
		System::Void localtrackBar_Scroll                      (System::Object^ sender, System::EventArgs^ e);
		System::Void localtrackBar_Enter                       (System::Object^ sender, System::EventArgs^ e);
		System::Void localtextBox_Edit                         (System::Object^ sender, System::EventArgs^ e);
		System::Void localcheckBox_Changed                     (System::Object^ sender, System::EventArgs^ e);
		System::Void localtextBox_Changed                      (System::Object^ sender, System::EventArgs^ e);
		System::Void localtextBox_Leave                        (System::Object^ sender, System::EventArgs^ e);
		System::Void localtextBox_Enter                        (System::Object^ sender, System::EventArgs^ e);
		System::Void LoadReferenceFile_Click                   (System::Object^ sender, System::EventArgs^ e); 
		System::Void LoadParameterFile_Click                   (System::Object^ sender, System::EventArgs^ e); 
		System::Void SaveParameterFile_Click                   (System::Object^ sender, System::EventArgs^ e); 
		System::Void SaveResultFiles_Click                     (System::Object^ sender, System::EventArgs^ e);
		System::Void SaveGraphis_Click                         (System::Object^ sender, System::EventArgs^ e);
		System::Void SelectResults_Click                       (System::Object^ sender, System::EventArgs^ e); 
		System::Void BuildTarget_Click                         (System::Object^ sender, System::EventArgs^ e);		
		System::Void ResultStepBox_SelectedIndexChanged        (System::Object^ sender, System::EventArgs^ e);
		System::Void BuildTarget_AddFx                         (System::Object^ sender, System::EventArgs^ e);
		System::Void BuildTarget_AddFy                         (System::Object^ sender, System::EventArgs^ e);
		System::Void BuildTarget_DelFx                         (System::Object^ sender, System::EventArgs^ e);
		System::Void BuildTarget_DelFy                         (System::Object^ sender, System::EventArgs^ e);
		System::Void StoreTargetFile                           (System::Object^ sender, System::EventArgs^ e);
		System::Void LoadTargetFile                            (System::Object^ sender, System::EventArgs^ e);
		System::Void BuildTarget_Extension                     (System::Object^ sender, System::EventArgs^ e);
		System::Void numericUpDownTextChanged                  (System::Object^ sender, System::EventArgs^ e);	
		System::Void Form1_Activated                           (System::Object^ sender, System::EventArgs^ e);
		System::Void Form1_Click                               (System::Object^ sender, System::EventArgs^ e);
		System::Void ColorDialog_Click                         (System::Object^ sender, System::EventArgs^ e);
		System::Void referenceColorToolStripMenuItem_Click     (System::Object^ sender, System::EventArgs^ e);
	   System::Void additionalColorToolStripMenuItem_Click    (System::Object^ sender, System::EventArgs^ e);
		System::Void totalForceColorToolStripMenuItem_Click    (System::Object^ sender, System::EventArgs^ e);
		System::Void stickingForceColorToolStripMenuItem_Click (System::Object^ sender, System::EventArgs^ e);
		System::Void slidingForceColorToolStripMenuItem_Click  (System::Object^ sender, System::EventArgs^ e);
		System::Void AccuracyBoundsColor_Click                 (System::Object^ sender, System::EventArgs^ e);
		System::Void curveLinesWidthToolStripMenuItem_Click    (System::Object^ sender, System::EventArgs^ e);
		System::Void Sensitivity_Click                         (System::Object^ sender, System::EventArgs^ e);
      System::Void SensitivityAllSelected_Click              (System::Object^ sender, System::EventArgs^ e);     
		System::Void SensitivityAll_Click                      (System::Object^ sender, System::EventArgs^ e);
      System::Void Ranges_Click                              (System::Object^ sender, System::EventArgs^ e);
 		System::Void CorneringStiffnessClick                   (System::Object^ sender, System::EventArgs^ e);
      System::Void UserScale_Click                           (System::Object^ sender, System::EventArgs^ e);
		System::Void Reset_Click                               (System::Object^ sender, System::EventArgs^ e);		
		System::Void BestValues_Click                          (System::Object^ sender, System::EventArgs^ e);
		System::Void AboutToolStrip_Click                      (System::Object^ sender, System::EventArgs^ e); 
		System::Void OpenHelpToolStrip_Click                   (System::Object^ sender, System::EventArgs^ e); 
      System::Void SetPathOptimisation_Click                 (System::Object^ sender, System::EventArgs^ e);
      System::Void RunOptimisation_Scilab_Click              (System::Object^ sender, System::EventArgs^ e);
      System::Void RunOptimisation_Matlab_Click              (System::Object^ sender, System::EventArgs^ e);
      System::Void LoadOptiMethod_Click                      (System::Object^ sender, System::EventArgs^ e);
		System::Void LoadMFDataFile                            (System::Object^ sender, System::EventArgs^ e);
      System::Void BuildTargetFromMF                         (System::Object^ sender, System::EventArgs^ e);     
		System::Void RunTargetFromMF                           (System::Object^ sender, System::EventArgs^ e);		
		System::Void MainWindowSizeChange                      (System::Object^  sender, System::EventArgs^ e);
		System::Void targetFunctionColor_Click                 (System::Object^  sender, System::EventArgs^ e);
		System::Void targetPointColor_Click                    (System::Object^  sender, System::EventArgs^ e);
		System::Void Table_CellValueChanged            (System::Object^  sender, DataGridViewCellEventArgs^ e);
		System::Void Form1_Paint          (System::Object^  sender, System::Windows::Forms::PaintEventArgs^ e);
		System::Void panel1_Paint         (System::Object^  sender, System::Windows::Forms::PaintEventArgs^ e);
};
}

