#include "stdafx.h"
#include "OpenGLPlot.h"

namespace FormulaGUI {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

COpenGLPlot::COpenGLPlot(System::Windows::Forms::Panel ^parent, GLsizei iWidth, GLsizei iHeight)                     
///////////////////////////////////////////////////////////////////////////////////////////////////////////
// constructur of OpenGLCross-class
///////////////////////////////////////////////////////////////////////////////////////////////////////////
{
//
// --- create the OpenGL window of CreateParams class
//
   OpenGLWindow   = gcnew CreateParams;
//
// --- set the pointer of parent to ParentForm and create opengl window
//
   ParentForm = parent;
   CreateOpenGLWindow(iWidth,iHeight);

	pheigth = iHeight;
	pwidth  = iWidth;
	poff    =  18;

   NumberOfAdditionalFiles = 0;

	DoF              = 1;
	DoM              = 1;
	DoMA             = 0;
	DoFST            = 0;
	DoFSL            = 0;
	DoFiles          = 1;
	DoMRange         = 0;
	DoTime           = 0;
   DoTargetFunction = 0;
   DoTargetPoint    = 0;
   TheMessages      = 0;

   ColorA = 0.0f;          
   ColorR = 0.0f;          
   ColorG = 0.0f;          
   ColorB = 0.0f;          

   ColorA1 = 0.0f;          
   ColorR1 = 0.0f;          
   ColorG1 = 1.0f;          
   ColorB1 = 0.0f;          

   ColorA2 = 0.0f;          
   ColorR2 = 1.0f;          
   ColorG2 = 0.0f;          
   ColorB2 = 0.0f;          

   ColorA3 = 0.0f;          
   ColorR3 = 1.0f;      
   ColorG3 = 1.0f;        
   ColorB3 = 0.0f;          

   ColorA4 = 0.0f;          
   ColorR4 = 1.0f;     
   ColorG4 = 0.0f;          
   ColorB4 = 1.0f; 

   ColorA5 = 0.5f;          
   ColorR5 = 0.5f;     
   ColorG5 = 0.5f;          
   ColorB5 = 0.5f;  

   ColorA6 = 0.7f;          
   ColorR6 = 0.7f;     
   ColorG6 = 0.7f;          
   ColorB6 = 0.7f;    

   ColorA7 = 0.7f;          
   ColorR7 = 0.7f;     
   ColorG7 = 0.7f;          
   ColorB7 = 0.7f;    

	ColorA8 = 0.7f;          
   ColorR8 = 0.7f;     
   ColorG8 = 0.7f;          
   ColorB8 = 0.7f;    

	MeaLineW      = 2.0f;
	MeaLineWA     = 3.0f;
	SimLineW      = 2.0f;
	FSTLineW      = 1.0f;
	FSLLineW      = 1.0f;
	TargetFLineW  = 1.0f;
	TargetPLineW  = 1.0f;

	UFxmax      =  1.0;
	UFxmin      = -1.0;
	UFymax      =  1.0;
	UFymin      = -1.0;
	Usxmax      =  1.0;
	Usxmin      = -1.0;
	Usymax      =  1.0;
	Usymin      = -1.0;
	UTargetFmax = 50.0;
	UTargetPmax =  5.0;

	AccuracyBound = 5.0f;

	File1 = L"DesignStart.dat";
	File2 = L"DesignTarget.dat";
	File3 = L"DesignTargetMF.dat";

	UserScale      = false;
	FristUserScale = true;
}
COpenGLPlot::~COpenGLPlot(System::Void)
///////////////////////////////////////////////////////////////////////////////
// destructor
///////////////////////////////////////////////////////////////////////////////
{
   DestroyOpenGLWindow();
}
void COpenGLPlot::DestroyGLWindow()
///////////////////////////////////////////////////////////////////////////////
// create an opengl window (iwidth,iheight) based on a native window
///////////////////////////////////////////////////////////////////////////////
{
   DestroyOpenGLWindow();
}
void COpenGLPlot::CreateGLWindow(GLsizei iWidth, GLsizei iHeight)
///////////////////////////////////////////////////////////////////////////////
// create an opengl window (iwidth,iheight) based on a native window
///////////////////////////////////////////////////////////////////////////////
{
  CreateOpenGLWindow(iWidth,iHeight);
}
void COpenGLPlot::CreateOpenGLWindow(GLsizei iWidth, GLsizei iHeight)
///////////////////////////////////////////////////////////////////////////////
// create an opengl window (iwidth,iheight) based on a native window
///////////////////////////////////////////////////////////////////////////////
{
// --- Set the position on the form

	OpenGLWindow->X = 0;
	OpenGLWindow->Y = 0;
	OpenGLWindow->Height = iHeight;
   OpenGLWindow->Width  = iWidth;

	pheigth = iHeight;
	pwidth  = iWidth;

// --- Specify the form as the parent.

	OpenGLWindow->Parent = ParentForm->Handle;

// --- Create as a child of the specified parent and make OpenGL compliant (no clipping)

	OpenGLWindow->Style = WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_DISABLED ;
 
// --- Create the actual window

	this->CreateHandle(OpenGLWindow);

// --- Get the handle pointer

   m_hDC = GetDC((HWND)this->Handle.ToPointer());

// --- Update opengl 

   if( m_hDC )
   {
      m_hglrc = wglCreateContext(m_hDC);
      wglMakeCurrent(m_hDC, NULL);
      MySetPixelFormat(m_hDC);
      ReSizeGL((float)pwidth,(float)pheigth);
      InitGL();
   	BuildFont();
   }
}
GLint COpenGLPlot::MySetPixelFormat(HDC hdc)
///////////////////////////////////////////////////////////////////////////////
// 
///////////////////////////////////////////////////////////////////////////////
{
   static PIXELFORMATDESCRIPTOR pfd=	// pfd Tells Windows How We Want Things To Be
   {
	   sizeof(PIXELFORMATDESCRIPTOR),	// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |					// Format Must Support Window
		PFD_SUPPORT_OPENGL |					// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,						// Must Support Double Buffering
		PFD_TYPE_RGBA,							// Request An RGBA Format
		16,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,						// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,								// Accumulation Bits Ignored
		16,										// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,						// Main Drawing Layer
		0,											// Reserved
		0, 0, 0									// Layer Masks Ignored
	};
			
	GLint iPixelFormat; 
		 
// --- get the device context's best, available pixel format match 

	if( (iPixelFormat = ChoosePixelFormat(hdc, &pfd)) == 0 )
	{
		MessageBox::Show("ChoosePixelFormat Failed");
		return 0;
	}
			 
// --- make that match the device context's current pixel format 

	if( SetPixelFormat(hdc, iPixelFormat, &pfd) == FALSE )
	{
		MessageBox::Show("SetPixelFormat Failed");
		return 0;
	}

	if( (m_hglrc = wglCreateContext(m_hDC)) == NULL )
	{
		MessageBox::Show("wglCreateContext Failed");
		return 0;
	}

	if( (wglMakeCurrent(m_hDC, m_hglrc)) == NULL )
	{
		MessageBox::Show("wglMakeCurrent Failed");
		return 0;
	}

   return 1;
}
bool COpenGLPlot::InitGL(GLvoid)
///////////////////////////////////////////////////////////////////////////////
// setup of opengl
///////////////////////////////////////////////////////////////////////////////
{
	glShadeModel(GL_SMOOTH);							      
	glClearDepth(1.0f);									      
	glEnable(GL_DEPTH_TEST);							      
	glDepthFunc(GL_LEQUAL);								      
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	

	return TRUE;										         
}
GLvoid COpenGLPlot::ReSizeGL(float width, float heigth)		
///////////////////////////////////////////////////////////////////////////////
// Resize and initialise the gl window
///////////////////////////////////////////////////////////////////////////////
{
   if ( xscale == 0 ) xscale = 1;    // Prevent A Divide By Zero By
   if ( yscale == 0 ) yscale = 1;    // Prevent A Divide By Zero By
	
	pwidth  = (int) width;
	pheigth = (int) heigth;
	xscale  = 1.0;
	yscale  = 1.0;

	OpenGLWindow->X = 0;
	OpenGLWindow->Y = 0;
   OpenGLWindow->Width  = pwidth;
	OpenGLWindow->Height = pheigth;

   glViewport(0,0,pwidth,pheigth);	
	glMatrixMode(GL_PROJECTION);  	
	glLoadIdentity();		            

// --- calculate aspect ratio of window

	gluPerspective(45.0f,(GLfloat)pwidth/(GLfloat)pheigth,0.1f,100.0f);
	glMatrixMode(GL_MODELVIEW);	
	glLoadIdentity();		
}

BOOL COpenGLPlot::Draw0()
/////////////////////////////////////////////////////////////////////////////
// Draw 2d plot
/////////////////////////////////////////////////////////////////////////////
{ 
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);        
	glLoadIdentity();       
	glViewport(0,0,pwidth,pheigth);                     
   glMatrixMode(GL_PROJECTION); 
	glLoadIdentity();      
	glOrtho(0,pwidth,0,pheigth,0,pheigth);   
   glClearColor(ColorR,ColorG,ColorB,ColorA);          
	glPointSize(6.0);	
	glColor3f  (0.0,1.0,0.0);
//
// --- clear screen
//
	glFlush();                      
	glFinish();                     
   SwapBuffers(m_hDC);				  

	return (TRUE);
}
BOOL COpenGLPlot::Draw()
/////////////////////////////////////////////////////////////////////////////
// Draw 2d plot
/////////////////////////////////////////////////////////////////////////////
{ 
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);       
	glLoadIdentity();       
	glViewport(0,0,pwidth,pheigth);                     
   glMatrixMode(GL_PROJECTION);  
	glLoadIdentity();       
 	glOrtho(0,pwidth,0,pheigth,0,pheigth); 
   glClearColor(ColorR,ColorG,ColorB,ColorA);          
	glPointSize(6.0);	
	glDisable(GL_LINE_SMOOTH);
//
// --- plot
//
	DoScale();
	DoFrame();
	if ( DoM && !DoTime ) 
	{
		glColor3f  (ColorR1,ColorG1,ColorB1);  
		DoPlotMea  (1,1.0f); DoPlotMea (2,1.0f);
	}
	if ( DoMA && !DoTime ) 
	{
		glColor3f  (ColorR6,ColorG6,ColorB6);  
		DoPlotMeaA (1,1.0f); DoPlotMeaA(2,1.0f);
	}
	if ( DoMRange && !DoTime )
	{
		glColor3f  (ColorR5,ColorG5,ColorB5); 
		DoPlotMea(1,1.0f+AccuracyBound*0.01f);
		DoPlotMea(1,1.0f-AccuracyBound*0.01f);
		DoPlotMea(2,1.0f+AccuracyBound*0.01f);
		DoPlotMea(2,1.0f-AccuracyBound*0.01f);
	}
	if ( DoF && !DoTime ) 
	{
		glColor3f  (ColorR2,ColorG2,ColorB2);
		DoPlotSimF (1); DoPlotSimF (2);
	}
	if ( DoFST && !DoTime ) 
	{
		glColor3f  (ColorR3,ColorG3,ColorB3);
		DoPlotSimFST (1); DoPlotSimFST (2);
	}
	if ( DoFSL && !DoTime ) 
	{
		glColor3f  (ColorR4,ColorG4,ColorB4);
		DoPlotSimFSL (1); DoPlotSimFSL (2);
	}
	if ( DoTime ) 
	{
		if ( DoM              ) { DoPlotTimeMea    (1); DoPlotTimeMea    (2); }
		if ( DoMA             ) { DoPlotTimeMeaA   (1); DoPlotTimeMeaA   (2); }
		if ( DoF              ) { DoPlotTimeSim    (1);	DoPlotTimeSim    (2); }
		if ( DoFST            ) { DoPlotTimeSimFST (1);	DoPlotTimeSimFST (2); }
		if ( DoFSL            ) { DoPlotTimeSimFSL (1);	DoPlotTimeSimFSL (2); }
		if ( DoTargetFunction ) { DoPlotTimeTarget (1); }
		if ( DoTargetPoint    ) { DoPlotTimeTarget (2); }
	}
//
// --- get netto window size (without border stuff)
//
	glFlush();                      
	glFinish();                     
   SwapBuffers(m_hDC);				  

	return (TRUE);
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoFrame() 
/////////////////////////////////////////////////////////////////////////////
{
	char s[1024];
	char s0[]="%";
	String ^string;
   int slen;
  	double y01,y02,y03;

   y01 = (1.0 - Fxrange/Fxdelta)*0.45*pheigth/2.0 + poff + pheigth/2.0;
   y02 = (1.0 - Fxrange/Fxdelta)*0.45*pheigth/2.0 + poff;
//
// --- zero axis
//
	glColor3f  (0.2f,0.2f,0.2f);
	glBegin(GL_LINE_STRIP);					 
	  glVertex2d (2,       y01);
	  glVertex2d (pwidth-2,y01);
	glEnd();	

	glBegin(GL_LINE_STRIP);					 
	  glVertex2d (2,       y02);
	  glVertex2d (pwidth-2,y02);
	glEnd();	
//
// --- frame
//
	glLineWidth(1.0f);	
	glColor3f  (1.0f,0.7f,1.0f);
	glBegin(GL_LINE_STRIP);					 
	  glVertex2d (2,2);
	  glVertex2d (2,pheigth-2);
	  glVertex2d (pwidth-2,pheigth-2);
	  glVertex2d (pwidth-2,2);
	  glVertex2d (2,2);
	glEnd();	

	glBegin(GL_LINE_STRIP);					 
	  glVertex2d (2,       pheigth/2-2);
	  glVertex2d (pwidth-2,pheigth/2-2);
	glEnd();	

	glColor3f (1.0f,1.0f,1.0f);
//
// --- text
//
	if ( DoTime )
	{
		sprintf (s,"%5.2lf",tmin);
		BitmapOutput((float)(10.0*xscale),(float)(10.0*yscale),s);
		sprintf (s,"index [-]");
		BitmapOutput((float)(pwidth/2),(float)(10.0*yscale),s);
		sprintf (s,"%5.2lf",tmax);
		BitmapOutput((float)(pwidth-50*xscale),(float)(10.0*yscale),s); 

		sprintf (s,"%5.2lf",tmin);
		BitmapOutput((float)(10.0*xscale),(float)(10+pheigth/2),s);
		sprintf (s,"index [-]");
		BitmapOutput((float)(pwidth/2),(float)(10+pheigth/2),s);
		sprintf (s,"%5.2lf",tmax);
		BitmapOutput((float)(pwidth-50*xscale),(float)(10+pheigth/2),s);
	}
	else
	{
		sprintf (s,"%5.3lf",symin);
		BitmapOutput((float)(10.0*xscale),(float)(10.0*yscale),s);
		sprintf (s,"sy [deg]");
		BitmapOutput((float)(pwidth/2),(float)(10.0*yscale),s);
		sprintf (s,"%5.3lf",symax);
		BitmapOutput((float)(pwidth-50*xscale),(float)(10.0*yscale),s); 

		sprintf (s,"%5.3lf",sxmin);
		BitmapOutput((float)(10.0*xscale),(float)(10+pheigth/2),s);
		sprintf (s,"sx [-]");
		BitmapOutput((float)(pwidth/2),(float)(10*yscale+pheigth/2),s);
		sprintf (s,"%5.3lf",sxmax);
		BitmapOutput((float)(pwidth-50*xscale),(float)(10*yscale+pheigth/2),s);
	}

	sprintf (s,"%5.2lf",Fymin);
	BitmapOutput((float)(10.0*xscale),(float)(20.0*yscale),s);
	sprintf (s,"Fy [N]");
	BitmapOutput((float)(10*xscale),(float)(20+pheigth/4),s);
	sprintf (s,"%5.2lf",Fymax);
	BitmapOutput(10*xscale,(float)(20*yscale+pheigth/2-50*yscale),s); 

	sprintf (s,"%5.2lf",Fxmin);
	BitmapOutput((float)(10*xscale),(float)(20*yscale+pheigth/2),s);
	sprintf (s,"Fx [N]");
	BitmapOutput((float)(10*xscale),(float)(20*yscale+3*pheigth/4),s);
	sprintf (s,"%5.2lf",Fxmax);
	BitmapOutput((float)(10*xscale),(float)(20*yscale+pheigth-50*yscale),s); 

	y03 = pheigth-30*yscale;

	if ( DoM && DoFiles && !DoTime )
	{	
		glColor3f  (ColorR1,ColorG1,ColorB1);  
		sprintf (s,"Reference Force");
		BitmapOutput((float)(pwidth/8),(float)y03,s);
		y03 = y03 - 16*yscale;
	}
	if ( DoMA && DoFiles && !DoTime && NumberOfAdditionalFiles > 0 )
	{	
		glColor3f  (ColorR6,ColorG6,ColorB6);   
		sprintf (s,"Additional Reference Force");
		BitmapOutput((float)(pwidth/8),(float)y03,s);
		y03 = y03 - 16*yscale;
	}
	if ( DoF && DoFiles && !DoTime ) 
	{	
		glColor3f  (ColorR2,ColorG2,ColorB2);  
		sprintf (s,"Total Force");
		BitmapOutput((float)(pwidth/8),(float)y03,s);
		y03 = y03 - 16*yscale;
	}
	if ( DoFST && DoFiles && !DoTime ) 
	{	
		glColor3f  (ColorR3,ColorG3,ColorB3);  
		sprintf (s,"Sticking Force");
		BitmapOutput((float)(pwidth/8),(float)y03,s);
		y03 = y03 - 16*yscale;
	}
	if ( DoFSL && DoFiles && !DoTime ) 
	{	
		glColor3f  (ColorR4,ColorG4,ColorB4);  
		sprintf (s,"Sliding Force");
		BitmapOutput((float)(pwidth/8),(float)y03,s);
		y03 = y03 - 16*yscale;
	}
	if ( DoMRange && DoFiles && !DoTime )
	{	
		glColor3f  (ColorR5,ColorG5,ColorB5);  
		sprintf (s,"Accuracy Bounds %2.1f %s ",AccuracyBound,s0);
		BitmapOutput((float)(pwidth/8),(float)y03,s);
		y03 = y03 - 16*yscale;
	}
	if ( DoTime )
	{	
		glColor3f  (ColorR5,ColorG5,ColorB5);  
		sprintf (s,"TrackData");
		BitmapOutput((float)(pwidth/8),(float)y03,s);
		y03 = y03 - 16*yscale;
	}
	if ( DoFiles )
	{	
		y03 = pheigth/2-30*yscale;
		glColor3f (1.0f,1.0f,1.0f);
		slen = (int) (File1->Length); 
		if ( slen > 40 ) string = File1->Substring(slen-35,35); 
		else             string = File1;
		sprintf (s,"Modeldata = ...%s",string);
		BitmapOutput((float)(pwidth/8),(float)y03,s);

		y03 = y03 - 16*yscale;
		slen = (int) (File3->Length); 
		if ( slen > 40 ) string = File3->Substring(slen-35,35); 
		else             string = File3;
		sprintf (s,"Reference = ...%s",string);
		BitmapOutput((float)(pwidth/8),(float)y03,s);
	}
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPointFX(const double x, const double y) 
/////////////////////////////////////////////////////////////////////////////
{
	double xp,yp;

	xp = (1.0 + 2.0*x/sxdelta - sxrange/sxdelta)*0.46*pwidth  + 1.8*poff;
	yp = (1.0 + 2.0*y/Fxdelta - Fxrange/Fxdelta)*0.45*pheigth/2.0 + poff + pheigth/2.0;

	glVertex2d(xp,yp);
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPointFY(const double x, const double y) 
/////////////////////////////////////////////////////////////////////////////
{
	double xp,yp;

	xp = (1.0 + 2.0*x/sydelta - syrange/sydelta)*0.46*pwidth  + 1.8*poff;
	yp = (1.0 + 2.0*y/Fydelta - Fyrange/Fydelta)*0.45*pheigth/2.0 + poff;

	glVertex2d(xp,yp);
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPointTX(const double x, const double y) 
/////////////////////////////////////////////////////////////////////////////
{
	double xp,yp;

	xp = ( 1.0 + 2.0*x/sxdelta - sxrange/sxdelta)*0.46*pwidth  + 1.8*poff;
	yp = (       2.0*y/TargetFmax               )*0.45*pheigth/2.0 + poff + pheigth/2.0;

	glVertex2d(xp,yp);
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPointTY(const double x, const double y) 
/////////////////////////////////////////////////////////////////////////////
{
	double xp,yp;

	xp = ( 1.0 + 2.0*x/sydelta - syrange/sydelta)*0.46*pwidth  + 1.8*poff;
	yp = (       2.0*y/TargetPmax               )*0.45*pheigth/2.0 + poff;

	glVertex2d(xp,yp);
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPlotTimeMea(int idir) 
/////////////////////////////////////////////////////////////////////////////
{
	double Fx,Fy,sx,sy;
	int i,j,k;
	
	glLineWidth(MeaLineW);
	glColor3f  (ColorR1,ColorG1,ColorB1);  

	sxdelta = tdelta;
	sxrange = trange;
	sydelta = tdelta;
	syrange = trange;
//
// --- plot mea
//
   j = 0;
   for ( i=0; i<NumberOfFiles; i++ )
   {
		glBegin(GL_LINE_STRIP);	
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
//
// --- plot points
//
         if      ( idir == 1 && TargetDirectionPerFile[i] == 1 ) 
			{
	         sx = k;
				Fx = optidata[j+3];
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 && TargetDirectionPerFile[i] == 2 ) 
			{
	         sy = k;
				Fy = optidata[j+4];
				DoPointFY(sy,Fy);
			}
         else if ( idir == 1 && TargetDirectionPerFile[i] == 3 ) 
			{
	         sx = k;
				Fx = optidata[j+3];
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 && TargetDirectionPerFile[i] == 3 ) 
			{
	         sy = k;
				Fy = optidata[j+4];
				DoPointFY(sy,Fy);
			}
         j = j + (Ninput+1);
      }
		glEnd();	
   }
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPlotTimeMeaA(int idir) 
/////////////////////////////////////////////////////////////////////////////
{
	double Fx,Fy,sx,sy;
	int i,j,k;
	
	glLineWidth(MeaLineWA);
	glColor3f  (ColorR6,ColorG6,ColorB6);  

	sxdelta = tdelta;
	sxrange = trange;
	sydelta = tdelta;
	syrange = trange;
//
// --- additional reference data
//
	j = JRange;
   for ( i=NumberOfFiles; i<NumberOfFiles+NumberOfAdditionalFiles; i++ )
   {
		glBegin(GL_LINE_STRIP);	
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
//
// --- plot points
//
         if      ( idir == 1 && TargetDirectionPerFile[i] == 1 ) 
			{
	         sx = k;
				Fx = optidata[j+3];
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 && TargetDirectionPerFile[i] == 2 ) 
			{
	         sy = k;
				Fy = optidata[j+4];
				DoPointFY(sy,Fy);
			}
         else if ( idir == 1 && TargetDirectionPerFile[i] == 3 ) 
			{
	         sx = k;
				Fx = optidata[j+3];
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 && TargetDirectionPerFile[i] == 3 ) 
			{
	         sy = k;
				Fy = optidata[j+4];
				DoPointFY(sy,Fy);
			}
         j = j + (Ninput+1);
      }
		glEnd();	
   }
}
////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPlotTimeSim(int idir) 
/////////////////////////////////////////////////////////////////////////////
{
	double Fx,Fy,sx,sy;
	int i,j,k;

	sxdelta = tdelta;
	sxrange = trange;
	sydelta = tdelta;
	syrange = trange;
//
// --- plot sim
//
	glLineWidth(SimLineW);
	glColor3f  (ColorR2,ColorG2,ColorB2);  

   j = 0;
   for ( i=0; i<NumberOfFiles; i++ )
   {
		glBegin(GL_LINE_STRIP);	
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
			if ( k > 5200 )
			{
				k = k+1-1;
			}
//
// --- plot points
//
         if     ( idir == 1 ) 
			{
	         sx = k;
				Fx = resultdata[j ];
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 ) 
			{
	         sy = k;
				Fy = resultdata[j+1];
				DoPointFY(sy,Fy);
			}
         j = j + (Ninput+1);
      }
		glEnd();	
   }
}
////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPlotTimeSimFST(int idir) 
/////////////////////////////////////////////////////////////////////////////
{
	double Fx,Fy,sx,sy;
	int i,j,k;

	sxdelta = tdelta;
	sxrange = trange;
	sydelta = tdelta;
	syrange = trange;
//
// --- plot sim
//
	glLineWidth(FSTLineW);
	glColor3f  (ColorR3,ColorG3,ColorB3);  

   j = 0;
   for ( i=0; i<NumberOfFiles; i++ )
   {
		glBegin(GL_LINE_STRIP);	
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
//
// --- plot points
//
         if     ( idir == 1 ) 
			{
	         sx = k;
				Fx = resultdata[j+3];
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 ) 
			{
	         sy = k;
				Fy = resultdata[j+5];
				DoPointFY(sy,Fy);
			}
         j = j + (Ninput+1);
      }
		glEnd();	
   }
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPlotTimeSimFSL(int idir) 
/////////////////////////////////////////////////////////////////////////////
{
	double Fx,Fy,sx,sy;
	int i,j,k;

	sxdelta = tdelta;
	sxrange = trange;
	sydelta = tdelta;
	syrange = trange;
//
// --- plot sim
//
	glLineWidth(FSLLineW);
	glColor3f  (ColorR4,ColorG4,ColorB4);  

   j = 0;
   for ( i=0; i<NumberOfFiles; i++ )
   {
		glBegin(GL_LINE_STRIP);	
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
//
// --- plot points
//
         if      ( idir == 1 ) 
			{
	         sx = k;
				Fx = resultdata[j+4];
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 ) 
			{
	         sy = k;
				Fy = resultdata[j+6];
				DoPointFY(sy,Fy);
			}
         j = j + (Ninput+1);
      }
		glEnd();	
   }
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPlotTimeTarget(int idir) 
/////////////////////////////////////////////////////////////////////////////
{
	double Tx,Ty,sx,sy;
	int i,j,k;

	sxdelta = tdelta;
	sxrange = trange;
	sydelta = tdelta;
	syrange = trange;
//
// --- plot target
//
	if      ( idir == 1 )
	{
		glLineWidth(TargetFLineW);
		glColor3f  (ColorR7,ColorG7,ColorB7);  
	}
	else
	{
		glLineWidth(TargetPLineW);
		glColor3f  (ColorR8,ColorG8,ColorB8);  
	}

   j = 0;
   for ( i=0; i<NumberOfFiles; i++ )
   {
		glBegin(GL_LINE_STRIP);	
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
//
// --- plot target points
//
         if      ( idir == 1 ) 
			{
	         sx = k;
				Tx = optidata[j+8];
				DoPointTX(sx,Tx);
			}
         else if ( idir == 2 ) 
			{
	         sy = k;
				Ty = resultdata[j+8];
				DoPointTY(sy,Ty);
			}
         j = j + (Ninput+1);
      }
		glEnd();	
   }
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPlotMea(int idir, float factor) 
/////////////////////////////////////////////////////////////////////////////
{
	double Fx,Fy,sx,sy;
	int i,j,k;
	
	glLineWidth(MeaLineW);
	if ( factor > 1.001  ||  factor < 0.999 ) glLineWidth(MeaLineW/2);

   j = 0;
   for ( i=0; i<NumberOfFiles; i++ )
   {
		glBegin(GL_LINE_STRIP);	
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
//
// --- plot points
//
         if      ( idir == 1 && TargetDirectionPerFile[i] == 1 ) 
			{
	         sx = optidata[j];
				Fx = optidata[j+3]*((double)factor);   
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 && TargetDirectionPerFile[i] == 2 ) 
			{
	         sy = optidata[j+1];
				Fy = optidata[j+4]*((double)factor);  
				DoPointFY(sy,Fy);
			}
         else if ( idir == 1 && TargetDirectionPerFile[i] == 3 ) 
			{
	         sx = optidata[j];
				Fx = optidata[j+3]*((double)factor);
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 && TargetDirectionPerFile[i] == 3 ) 
			{
	         sy = optidata[j+1];
				Fy = optidata[j+4]*((double)factor);
				DoPointFY(sy,Fy);
			}
         j = j + (Ninput+1);
      }
		glEnd();	
   }
	JRange = j;
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPlotMeaA(int idir, float factor) 
/////////////////////////////////////////////////////////////////////////////
{
	double Fx,Fy,sx,sy;
	int i,j,k;
	
	glLineWidth(MeaLineWA);
	if ( factor > 1.001  ||  factor < 0.999 ) glLineWidth(MeaLineW/2);

   j = JRange;
   for ( i=NumberOfFiles; i<NumberOfFiles+NumberOfAdditionalFiles; i++ )
   {
		glBegin(GL_LINE_STRIP);	
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
//
// --- plot points
//
         if      ( idir == 1 && TargetDirectionPerFile[i] == 1 ) 
			{
	         sx = optidata[j];
				Fx = optidata[j+3]*((double)factor);
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 && TargetDirectionPerFile[i] == 2 ) 
			{
	         sy = optidata[j+1];
				Fy = optidata[j+4]*((double)factor);
				DoPointFY(sy,Fy);
			}
         else if ( idir == 1 && TargetDirectionPerFile[i] == 3 ) 
			{
	         sx = optidata[j];
				Fx = optidata[j+3]*((double)factor);
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 && TargetDirectionPerFile[i] == 3 ) 
			{
	         sy = optidata[j+1];
				Fy = optidata[j+4]*((double)factor);
				DoPointFY(sy,Fy);
			}
         j = j + (Ninput+1);
      }
		glEnd();	
   }
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPlotSimF(int idir) 
/////////////////////////////////////////////////////////////////////////////
{
	double Fx,Fy,sx,sy;
	int i,j,k;
	
	glLineWidth(SimLineW);	

   j = 0;
   for ( i=0; i<NumberOfFiles; i++ )
   {
		glBegin(GL_LINE_STRIP);	
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
//
// --- plot points
//
         if     ( idir == 1 ) 
			{
	         sx = optidata[j];
				Fx = resultdata[j]; 
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 ) 
			{
	         sy = optidata[j+1];      
            Fy = resultdata[j+1];  
				DoPointFY(sy,Fy);
			}
         j = j + (Ninput+1);
      }
		glEnd();	
   }
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPlotSimFST(int idir) 
/////////////////////////////////////////////////////////////////////////////
{
	double Fx,Fy,sx,sy;
	int i,j,k;

	glLineWidth(FSTLineW);	

   j = 0;
   for ( i=0; i<NumberOfFiles; i++ )
   {
		glBegin(GL_LINE_STRIP);	
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
//
// --- plot points
//
         if      ( idir == 1 ) 
			{
	         sx = optidata[j];
				Fx = resultdata[j+3];
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 ) 
			{
	         sy = optidata[j+1];
				Fy = resultdata[j+5];
				DoPointFY(sy,Fy);
			}
         j = j + (Ninput+1);
      }
		glEnd();	
   }
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoPlotSimFSL(int idir) 
/////////////////////////////////////////////////////////////////////////////
{
	double Fx,Fy,sx,sy;
	int i,j,k;
	
	glLineWidth(FSLLineW);	

   j = 0;
   for ( i=0; i<NumberOfFiles; i++ )
   {
		glBegin(GL_LINE_STRIP);	
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
//
// --- plot points
//
         if      ( idir == 1 ) 
			{
	         sx = optidata[j];
				Fx = resultdata[j+4];
				DoPointFX(sx,Fx);
			}
         else if ( idir == 2 ) 
			{
	         sy = optidata[j+1];
				Fy = resultdata[j+6];
				DoPointFY(sy,Fy);
			}
         j = j + (Ninput+1);
      }
		glEnd();	
   }
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::DoScale() 
/////////////////////////////////////////////////////////////////////////////
{
	double Fx1,Fx2,Fy1,Fy2,sx,sy;
	int i,j,k,lx=0,ly=0;

	glLineWidth(1.0f);
	tmin = 0.0;
	tmax = 0.0;

	TargetFmax = 0.0;
	TargetPmax = 0.0;

   TheMessages = 0;

	for ( i=0; i<NumberOfFiles+NumberOfAdditionalFiles; i++ )
	{
		if ( PointsPerFile[i] > tmax ) tmax = (double) PointsPerFile[i];
	}

	if ( UserScale )
	{
		Fxmax      = UFxmax;
		Fxmin      = UFxmin;
		Fymax      = UFymax;
		Fymin      = UFymin;
		sxmax      = Usxmax;
		sxmin      = Usxmin;
		symax      = Usymax;
		symin      = Usymin;
		TargetFmax = UTargetFmax;
		TargetPmax = UTargetPmax;
	}

	j = 0;
   for ( i=0; i<NumberOfFiles; i++ )
   {
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
         sx = optidata [j  ];
         sy = optidata [j+1];
//
// --- find range in longitudinal direction
//
         if ( TargetDirectionPerFile[i] == 1 || TargetDirectionPerFile[i] == 3 ) 
			{
				if ( DoF )
				{
					Fx1 = mymax(optidata[j+3],resultdata[j]);
					Fx2 = mymin(optidata[j+3],resultdata[j]);
				}
				else if ( !DoF && DoFST )
				{
					Fx1 = mymax(optidata[j+3],resultdata[j+3]);
					Fx2 = mymin(optidata[j+3],resultdata[j+3]);
				}
				else if ( !DoF && DoFSL )
				{
					Fx1 = mymax(optidata[j+3],resultdata[j+4]);
					Fx2 = mymin(optidata[j+3],resultdata[j+4]);
				}
				else if ( !DoF && !DoFSL && !DoFST )
				{
					Fx1 = optidata[j+3];
					Fx2 = optidata[j+3];
				}
				if ( lx == 0 )
				{
					lx = 1;
					if ( ! UserScale )
					{
						Fxmax = Fx1;
						Fxmin = Fx2;
						sxmax = sx;
						sxmin = sx;
					}
				}
				else
				{
					if ( ! UserScale )
					{
						if ( Fx1 > Fxmax ) Fxmax = Fx1;
						if ( Fx2 < Fxmin ) Fxmin = Fx2;
						if (  sx > sxmax ) sxmax = sx;
						if (  sx < sxmin ) sxmin = sx;
					}
				}
			}
//
// --- find range in lateral direction
//
         if ( TargetDirectionPerFile[i] == 2 || TargetDirectionPerFile[i] == 3 ) 
			{
				if ( DoF )
				{
					Fy1 = mymax(optidata[j+4],resultdata[j+1]);
					Fy2 = mymin(optidata[j+4],resultdata[j+1]);
				}
				else if ( !DoF && DoFST )
				{
					Fy1 = mymax(optidata[j+4],resultdata[j+5]);
					Fy2 = mymin(optidata[j+4],resultdata[j+5]);
				}
				else if ( !DoF && DoFSL )
				{
					Fy1 = mymax(optidata[j+4],resultdata[j+6]);
					Fy2 = mymin(optidata[j+4],resultdata[j+6]);
				}
				else if ( !DoF && !DoFSL && !DoFST )
				{
					Fy1 = optidata[j+4];
					Fy2 = optidata[j+4];
				}
				if ( ly == 0 )
				{
					ly = 1;
					if ( ! UserScale )
					{
						Fymax = Fy1;
						Fymin = Fy2;
						symax = sy;
						symin = sy;
					}
				}
				else
				{
					if ( ! UserScale )
					{
						if ( Fy1 > Fymax ) Fymax = Fy1;
						if ( Fy2 < Fymin ) Fymin = Fy2;
						if (  sy > symax ) symax = sy;
						if (  sy < symin ) symin = sy;
					}
				}			
			}
//
// --- target stuff
//
			if ( ! UserScale )
			{
			  if ( resultdata [j+8] > TargetPmax ) TargetPmax = resultdata [j+8];
			  if ( optidata   [j+8] > TargetFmax ) TargetFmax = optidata   [j+8];
			}

         j = j + (Ninput+1);
      }
   }
//
// --- scaling in additional data
//
   for ( i=NumberOfFiles; i<NumberOfFiles+NumberOfAdditionalFiles; i++ )
   {
      for ( k=0; k<PointsPerFile[i]; k++ )
      {
         sx = optidata [j  ];
         sy = optidata [j+1];
//
// --- find range in longitudinal direction
//
         if ( TargetDirectionPerFile[i] == 1 || TargetDirectionPerFile[i] == 3 ) 
			{
				if ( DoMA )
				{
					Fx1 = optidata[j+3];
					Fx2 = optidata[j+3];
				}
				if ( lx == 0 )
				{
					lx = 1;
					if ( ! UserScale )
					{
						Fxmax = Fx1;
						Fxmin = Fx2;
						sxmax = sx;
						sxmin = sx;
					}
				}
				else
				{
					if ( ! UserScale )
					{
						if ( Fx1 > Fxmax ) Fxmax = Fx1;
						if ( Fx2 < Fxmin ) Fxmin = Fx2;
						if (  sx > sxmax ) sxmax = sx;
						if (  sx < sxmin ) sxmin = sx;
					}
				}
			}
//
// --- find range in lateral direction
//
         if ( TargetDirectionPerFile[i] == 2 || TargetDirectionPerFile[i] == 3 ) 
			{
				if ( DoMA )
				{
					Fy1 = optidata[j+4];
					Fy2 = optidata[j+4];
				}
				if ( ly == 0 )
				{
					ly = 1;
					if ( ! UserScale )
					{
						Fymax = Fy1;
						Fymin = Fy2;
						symax = sy;
						symin = sy;
					}
				}
				else
				{
					if ( ! UserScale )
					{
						if ( Fy1 > Fymax ) Fymax = Fy1;
						if ( Fy2 < Fymin ) Fymin = Fy2;
						if (  sy > symax ) symax = sy;
						if (  sy < symin ) symin = sy;
					}
				}			
			}
         j = j + (Ninput+1);
      }
   }
	Fxdelta = Fxmax - Fxmin;
	Fydelta = Fymax - Fymin;
	sxdelta = sxmax - sxmin;
	sydelta = symax - symin;

	Fxrange = Fxmax + Fxmin;
	Fyrange = Fymax + Fymin;
	sxrange = sxmax + sxmin;
	syrange = symax + symin;

	trange  = tmax + tmin;
	tdelta  = tmax - tmin;

	if ( fabs(Fxdelta) < 1.0e-12 ) Fxdelta = 1.0;
	if ( fabs(Fydelta) < 1.0e-12 ) Fydelta = 1.0;
	if ( fabs(sxdelta) < 1.0e-12 ) sxdelta = 1.0;
	if ( fabs(sydelta) < 1.0e-12 ) sydelta = 1.0;

	if ( FristUserScale )
	{
		UFxmax      = Fxmax;
		UFxmin      = Fxmin;
		UFymax      = Fymax;
		UFymin      = Fymin;
		Usxmax      = sxmax;
		Usxmin      = sxmin;
		Usymax      = symax;
		Usymin      = symin;
		UTargetFmax = TargetFmax;
		UTargetPmax = TargetPmax;

		FristUserScale = false;
	}
}
//-----------------------------------------------------------------------------------------------------
double COpenGLPlot::mymax ( const double value1, const double value2 )
//-----------------------------------------------------------------------------------------------------
// return max(x,y)
//-----------------------------------------------------------------------------------------------------
{
   if ( value1 > value2 ) return ( value1 );
   return ( value2 );
}
//-----------------------------------------------------------------------------------------------------
double COpenGLPlot::mymin ( const double value1, const double value2 )
//-----------------------------------------------------------------------------------------------------
// return min(x,y)
//-----------------------------------------------------------------------------------------------------
{
   if ( value1 < value2 ) return ( value1 );
   return ( value2 );
}
GLvoid COpenGLPlot::BuildFont(GLvoid)
/////////////////////////////////////////////////////////////////////////////
// COpenGLTyre:: build our bitmap of font, using fonts fo windows
/////////////////////////////////////////////////////////////////////////////
{
	HFONT	font;						// windows font ID
	HFONT	oldfont;					// used for good house keeping

   base = glGenLists(96); 	   // storage for 96 characters, use 96 charakters starting at 32 "space"

   font = CreateFont(-12,0,0,0,                 // height, width ,angle of escapement, orientation angle
                     FW_NORMAL,                 // font Weight
                     FALSE,                     // italic
                     FALSE,                     // underline
                     FALSE, 			            // strikeout
                     ANSI_CHARSET, 					// character Set Identifier
	                  OUT_TT_PRECIS, 				// output Precision
	                  CLIP_DEFAULT_PRECIS, 		// clipping Precision
	                  ANTIALIASED_QUALITY, 		// output Quality
                     FF_DONTCARE|FIXED_PITCH, 	// family And Pitch
                     LPWSTR("Arial")); 			// font Name, Windows Member

	oldfont = (HFONT)SelectObject(m_hDC, font); 	// selects the font

   wglUseFontBitmaps(m_hDC, 32, 96, base); // builds 96 characters starting at character 32		
	
	SelectObject(m_hDC, oldfont); // selects the font we want
	DeleteObject(font); 			   // delete the font
}
GLvoid COpenGLPlot::KillFont(GLvoid)
/////////////////////////////////////////////////////////////////////////////
// COpenGLTyre:: delete the font list
/////////////////////////////////////////////////////////////////////////////
{
   glDeleteLists(base, 96);
}

BOOL COpenGLPlot::BitmapOutput(float x,float y,char *string)
/////////////////////////////////////////////////////////////////////////////
// COpenGLTyre:: write string at coordinates x,y,z
/////////////////////////////////////////////////////////////////////////////
{
   if ( string == NULL ) return FALSE; 

	glRasterPos2f(x,y);                 
  	glPushAttrib(GL_LIST_BIT); 	      
	glListBase(base - 32); 			      
	glCallLists((GLsizei)strlen(string),GL_UNSIGNED_BYTE,string);   
	glPopAttrib();                     

   return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
void COpenGLPlot::GeneratePicture( String ^s )
/////////////////////////////////////////////////////////////////////////////
// --- from COpenGLTyre:: generate picture of current view
/////////////////////////////////////////////////////////////////////////////
{
   int    j,k,l,count1,count2,count3;
   int    h1,sum;
   BYTE  *bmBits;

   System::Drawing::Bitmap ^bmp;
   System::Drawing::Image  ^image;
   
   // --- allocate the memory of all pixel of one picture, number of pixel = width*heigth, 3 colors
   bmBits = new BYTE[pheigth*pwidth*3];

   // --- create the bitmap with doubled dimension
   bmp = gcnew System::Drawing::Bitmap(pwidth,pheigth); 

   // --- create an graphics objekt to the bitmap and set the background color
   System::Drawing::Graphics ^g = Graphics::FromImage(bmp);
	g->Clear(Color::FromArgb((int)ColorR,(int)ColorG,(int)ColorB)); 

   // --- redraw the current view and read the pixels
   Draw();
   glPixelStoref(GL_PACK_ALIGNMENT,1);
   glReadBuffer(GL_FRONT);
   glReadPixels(0,0,pwidth,pheigth,GL_RGB,GL_UNSIGNED_BYTE,bmBits);
 
	// --- add the single picture informations to the result bitmap
	for (j=0; j<pheigth; j++)
   {
      h1 = pheigth  -(j+1);
      l  = j*pwidth;
      
      for (k=0; k<pwidth; k++) 
      {
         count1 = 3*(l+k);
         count2 = count1+1;
         count3 = count1+2;
        
         // --- get the sum of all 3 colors
         sum = (int)(bmBits[count1]) + (int)(bmBits[count2]) + (int)(bmBits[count3]); 
         
         // --- add picture informations to bitmap if pixel not black "zero"
         if ( sum != 0 ) bmp->SetPixel(k,h1,Color::FromArgb((int)(bmBits[count1]),(int)(bmBits[count2]),(int)(bmBits[count3])));
      }
   }

   image = dynamic_cast<System::Drawing::Image^>(bmp);
   image->Save(s);
   delete[] bmBits;
}
}