#include "stdafx.h"
#include "RMOD_K_Formula_Run.h"
#include "RMOD_K_Formula_Opti.h"

int main( int argc, char *argv[] )
{
   FILE  *INPUT;
   FILE  *OUTPUT;
   FILE  *DATA;
   char   s[256],snumber[10],send[2]="\0",*s1;
   char   InputFileName  [256];
   char   OutputFileName1[256]="FormulaOutputx.dat\0";
   char   OutputFileName2[256]="FormulaFinputx.dat\0";
   int    i,j,npoints,irun=0;
   double value1,value2,value3,value4,value5,value6,value7,VT;

   CRMOD_K_Formula_Run  RMOD_K_Formula;
//
// --- check number of input arguments
//
   if ( argc != 2 )
   {
      printf ( " number of arguments should be 1: inputfile \n" );
      return ( 0 );
   }
//
// --- get filename and try to open
//
   if ( ( INPUT = fopen ( argv[1],"r+" ) ) == NULL )
   {
      printf ( " unable to open input file %s\n",argv[1] );
      return( 0 );
   }
//
// --- read job definition file
//
   while ( fgets ( s,256,INPUT ) )
   {
      if ( strstr ( s,"[Eof]" ) ) break;
//
// --- read formula data filename ----------------------------------------------------------------
//
      if ( strstr ( s,"[DataFileName]" ) )
      {
         fgets  ( s,256,INPUT );
         strncpy ( s+strlen( s )-1,send,2 );
         strcpy  ( RMOD_K_Formula.DataFileName,s );

         RMOD_K_Formula.ReadFile_Formula();
      }
//
// --- single input data - single run
//
      else if ( strstr ( s,"[SingleInput" ) )
      {
         for ( i=0; i<Ninput3; i++ )
         {
            fgets ( s,256,INPUT );
            s1 = strstr ( s,"=" ) + 1;
            sscanf ( s1,"%lf",&( RMOD_K_Formula.input3[i] ) );
         }

         RMOD_K_Formula.set_draw3d       ( 1 );
			RMOD_K_Formula.set_dataexchange ( 1 );
         RMOD_K_Formula.Initialize       ();
         RMOD_K_Formula.Evaluate_Formula ();
         printf ( " Fx   = %lf, Fy = %lf, Mz = %lf \n",RMOD_K_Formula.output[0],RMOD_K_Formula.output[1],RMOD_K_Formula.output[2] );
         RMOD_K_Formula.GetSize_Formula  ( &value1,&value2,&value3,&value4  );
         printf ( " True area = %lf,  h = %lf,  b = %lf, h*b = %lf , dA = %lf\n",value1,value2,value3,4.0*value2*value3,value4 );
      }
//
// --- range input data - range run ----------------------------------------------------------------
//
      else if ( strstr ( s,"[RangeInput" ) )
      {
         RMOD_K_Formula.set_draw3d( 0 );
//
// --- number of data points
//
         fgets ( s,256,INPUT );
         s1 = strstr ( s,"=" ) + 1;
         sscanf ( s1,"%d",&npoints );
//
// --- output file name
//
         fgets ( s,256,INPUT );
         s1 = strstr ( s,"=" ) + 1;
         sscanf ( s1,"%s",OutputFileName1 );
//
// --- max inputs
//
         fgets ( s,256,INPUT );
         for ( i=0; i<Ninput3; i++ )
         {
            fgets ( s,256,INPUT );
            s1 = strstr ( s,"=" ) + 1;
            sscanf ( s1,"%lf",&( RMOD_K_Formula.RangeMax[i] ) );
         }
//
// --- min inputs
//
         fgets ( s,256,INPUT );
         for ( i=0; i<Ninput3; i++ )
         {
            fgets ( s,256,INPUT );
            s1 = strstr ( s,"=" ) + 1;
            sscanf ( s1,"%lf",&( RMOD_K_Formula.RangeMin[i] ) );
         }
//
// --- run output filename
//
         irun++;
         if ( ( OUTPUT = fopen ( OutputFileName1,"w+" ) ) == NULL )
         {
            printf ( " unable to open output file %s\n",OutputFileName1 );
            return( 0 );
         }

         for ( i=0; i<npoints; i++ )
         {
            value1 = ( ( double ) i )/( ( double ) ( npoints-1 ) );
            for ( j=0; j<Ninput3; j++ )
            {
               RMOD_K_Formula.input3[j] = RMOD_K_Formula.RangeMin[j] + value1 *( RMOD_K_Formula.RangeMax[j] - RMOD_K_Formula.RangeMin[j] );
            }

				if ( i == 0 )
				{
					RMOD_K_Formula.set_draw3d       ( 1 );
					RMOD_K_Formula.set_dataexchange ( 1 );
					RMOD_K_Formula.Initialize       ();
				}
            RMOD_K_Formula.Evaluate_Formula ();
            fprintf ( OUTPUT," %+12.6e %+12.6e %+12.6e",          RMOD_K_Formula.input3[0],RMOD_K_Formula.input3[1],RMOD_K_Formula.input3[2] );
            fprintf ( OUTPUT," %+12.6e %+12.6e %+12.6e %+12.6e  ",RMOD_K_Formula.output[0],RMOD_K_Formula.output[1],RMOD_K_Formula.input3[3],RMOD_K_Formula.output[2] );
            fprintf ( OUTPUT," %+12.6e %+12.6e %+12.6e %+12.6e\n",RMOD_K_Formula.output[3],RMOD_K_Formula.output[4],RMOD_K_Formula.input3[5],RMOD_K_Formula.output[6] );
         }
         fclose ( OUTPUT );
      }
//
// --- input data from file ----------------------------------------------------------------
//
      else if ( strstr ( s,"[FileInput" ) )
      {
//
// --- read filename and test velocity
//
         fgets   ( s,256,INPUT );
         s1 = strstr ( s,"=" ) + 1;
         sscanf ( s1,"%s",InputFileName );
         s1 = strstr ( s1,"=" ) + 1;
         sscanf ( s1,"%lf",&VT );
//
// --- get filename and try to open
//
         if ( ( DATA = fopen ( InputFileName,"r+" ) ) == NULL )
         {
            printf ( " unable to open data file %s\n",s );
            return( 0 );
         }

         RMOD_K_Formula.set_draw3d( 0 );
//
// --- run output filename
//
         irun++;
         sprintf ( snumber,"%d.dat",irun );
         strcpy ( OutputFileName2+13,snumber );
         if ( ( OUTPUT = fopen ( OutputFileName2,"w+" ) ) == NULL )
         {
            printf ( " unable to open output file %s\n",OutputFileName2 );
            return( 0 );
         }

         RMOD_K_Formula.input3[4] = VT;

         while ( fgets ( s,256,DATA ) )
         {
            sscanf ( s,"%lf%lf%lf%lf%lf%lf%lf",&value1,&value2,&value3,&value4,&value5,&value6,&value7 );
            RMOD_K_Formula.input3[0] = value1;
            RMOD_K_Formula.input3[1] = value2;
            RMOD_K_Formula.input3[2] = value3;
            RMOD_K_Formula.input3[3] = value6;

            RMOD_K_Formula.Evaluate_Formula ();
            fprintf ( OUTPUT," %+12.6e %+12.6e %+12.6e %+12.6e %+12.6e",RMOD_K_Formula.input3[0],RMOD_K_Formula.input3[1],
                      RMOD_K_Formula.input3[2],RMOD_K_Formula.input3[3],
                      RMOD_K_Formula.input3[4] );
            fprintf ( OUTPUT," %+12.6e %+12.6e %+12.6e ", value4,value5,value7 );
            fprintf ( OUTPUT," %+12.6e %+12.6e %+12.6e\n",RMOD_K_Formula.output[0],RMOD_K_Formula.output[1],RMOD_K_Formula.output[2] );
         }
         fclose ( OUTPUT );
         fclose ( DATA );
      }
   }
}

